UNIT BIGDATA_RXTX
	SYSTEM FP220AE

//-------------------------------------------------------------------------------------------------------
//
// Units
//
//-------------------------------------------------------------------------------------------------------
USES "Units\Unit_Waitms"
USES "Units\Unit_InOut"
USES "Units\Unit_BigData_Collect"

//-------------------------------------------------------------------------------------------------------
//
// CONST/VAR/ALIAS
//
//------------------------------------------------------------------------------------------------------

CONST

WITH_CUSTOMER_001                                      : BIT := TRUE; 

//WITH_TIMECHECK                                         : BIT := FALSE; 

//muss in der Haupt prc stehen!//EFKA_PROJEKTNUMMER                               : VALUE := 1050;
//muss in der Haupt prc stehen!//VERSIONSNUMMER                                   : VALUE := 26;
BIGDATA_VERSIONSNUMMER                           : VALUE := 31;//BigData-Units-Version
//muss in der Haupt prc stehen!//PARA_EFKA_PROJEKTNUMMER                          : VALUE := 777;//Eindeutige EFKA Versionsnummer
//muss in der Haupt prc stehen!//PARA_VERSION                                     : VALUE := 779;//Programm-Version
PARA_BIGDATA_VERSION                             : VALUE := 778;//BigData-Units-Version

LENGTH_RXD_BUFFER                                : VALUE := 1000;
PC_DEVICE_NUMBER_ADRESS                          : VALUE := 2;
BIGDATASTRINGSIZE                                : VALUE := 1500;//Maximale Buffergre
BIGDATASTRINGNUMBER                              : VALUE := 48;

//Values for SetTaskTime
TASKTIME_MIN                                     : VALUE := 1;
TASKTIME_MAX                                     : VALUE := 30;
//Naht_FktBasis.kconfl

SECTION_INFO_NORMAL                              : VALUE := 1;
SECTION_INFO_ZERO                                : VALUE := 2;
SECTION_INFO_REDUCED                             : VALUE := 3;

STRING_A23                                       : STRING := " A23";

//-------------------------------------------------------------------------------------------------------
// Message ID
//-------------------------------------------------------------------------------------------------------
/*00*/ BIGDATA_ID_SEND_NO                                     : VALUE := 0; 
/*01*/ BIGDATA_ID_SEND_OPERATOR_ID_LOGIN                      : VALUE := 1; 
/*02*/ BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT                     : VALUE := 2;  
/*03*/ BIGDATA_ID_SEND_POWER_ON                               : VALUE := 3;  
/*04*/ BIGDATA_ID_SEND_GETPARAMETER_ANSWER                    : VALUE := 4;  
/*05*/ BIGDATA_ID_SEND_SEW_INFORMATION                        : VALUE := 5;  
/*06*/ BIGDATA_ID_SEND_SERVICE_CALL                           : VALUE := 6;  
/*07*/ BIGDATA_ID_SEND_GETPARAMETER                           : VALUE := 7;  
/*08*/ BIGDATA_ID_SEND_SETPARAMETER                           : VALUE := 8;  
/*09*/ BIGDATA_ID_SEND_OPERATOR_ID_ANSWER                     : VALUE := 9;  
/*10*/ BIGDATA_ID_SEND_ACK_TO_CONTROL_BOX                     : VALUE := 10;  
/*11*/ BIGDATA_ID_SEND_RESETSTATUS                            : VALUE := 11; 
/*12*/ BIGDATA_ID_SEND_RESETSERVICECOUNTER                    : VALUE := 12;  
/*13*/ BIGDATA_ID_SEND_GETSERVICECOUNTER                      : VALUE := 13;  
/*14*/ BIGDATA_ID_SEND_GETSTATUS                              : VALUE := 14; 
/*15*/ BIGDATA_ID_SEND_RESETPIECECOUNTER                      : VALUE := 15;  
/*16*/ BIGDATA_ID_SEND_GETPIECECOUNTER                        : VALUE := 16; 
/*17*/ BIGDATA_ID_SEND_MESSAGEMODESETUP                       : VALUE := 17;  
/*18*/ BIGDATA_ID_SEND_ACK_TO_PC                              : VALUE := 18; 
/*19*/ BIGDATA_ID_SEND_GETSTATUS_ANSWER                       : VALUE := 19; 
/*20*/ BIGDATA_ID_SEND_PIECECOUNTER_READY_0                   : VALUE := 20; 
/*21*/ BIGDATA_ID_SEND_SERVICECOUNTER_READY_0                 : VALUE := 21;  
/*22*/ BIGDATA_ID_SEND_SERVICECOUNTER_READY_1                 : VALUE := 22;  
/*23*/ BIGDATA_ID_SEND_SERVICECOUNTER_READY_2                 : VALUE := 23;  
/*24*/ BIGDATA_ID_SEND_SERVICECOUNTER_READY_3                 : VALUE := 24;  
/*25*/ BIGDATA_ID_SEND_SERVICECOUNTER_READY_4                 : VALUE := 25;  
/*26*/ BIGDATA_ID_SEND_PIECECOUNTER_VALUE_0                   : VALUE := 26;  
/*27*/ BIGDATA_ID_SEND_DISABLEOUTPUT                          : VALUE := 27;  
/*28*/ BIGDATA_ID_SEND_SETOUTPUT                              : VALUE := 28; 
/*29*/ BIGDATA_ID_SEND_SETPROGRAMMINGMODE                     : VALUE := 29;  
/*30*/ BIGDATA_ID_SEND_GET_CONTROLBOX_STATUS                  : VALUE := 30;  
/*31*/ BIGDATA_ID_SEND_SERVICECOUNTER_VALUE_0                 : VALUE := 31;  
/*32*/ BIGDATA_ID_SEND_SERVICECOUNTER_VALUE_1                 : VALUE := 32;  
/*33*/ BIGDATA_ID_SEND_SERVICECOUNTER_VALUE_2                 : VALUE := 33;  
/*34*/ BIGDATA_ID_SEND_SERVICECOUNTER_VALUE_3                 : VALUE := 34;  
/*35*/ BIGDATA_ID_SEND_SERVICECOUNTER_VALUE_4                 : VALUE := 35;  
/*36*/ BIGDATA_ID_SEND_GET_CONTROLBOX_STATUS_ANSWER           : VALUE := 36;  
/*37*/ BIGDATA_ID_SEND_LOCKCONTROLBOX                         : VALUE := 37;  
/*38*/ BIGDATA_ID_SEND_RESTARTCONTROLBOX                      : VALUE := 38;  
/*39*/ BIGDATA_ID_SEND_SERVICECALL_ACKNOWLEDGE                : VALUE := 39;  
/*40*/ BIGDATA_ID_SEND_RUNBLOCKAGE                            : VALUE := 40;  
/*41*/ BIGDATA_ID_SEND_POWER_OFF                              : VALUE := 41;  
/*42*/ BIGDATA_ID_SEND_REQUST_POWER_ON                        : VALUE := 42; 
/*43*/ BIGDATA_ID_SEND_SHORT_SEW_INFORMATION                  : VALUE := 43; 
/*44*/ BIGDATA_ID_SEND_WATCHDOGMESSAGE                        : VALUE := 44; 
/*45*/ BIGDATA_ID_SEND_ERROR_TO_PC                            : VALUE := 45;
/*46*/ BIGDATA_ID_SEND_FREE2                                  : VALUE := 46;
/*47*/ BIGDATA_ID_SEND_ERROR_TO_CONTROL_BOX                   : VALUE := 47;         
/*48*/ BIGDATA_ID_SEND_SENSOR_CLOSE_01                        : VALUE := 48;          
/*49*/ BIGDATA_ID_SEND_SENSOR_CLOSE_02                        : VALUE := 49;         
/*50*/ BIGDATA_ID_SEND_SENSOR_CLOSE_03                        : VALUE := 50;          
/*51*/ BIGDATA_ID_SEND_SENSOR_CLOSE_04                        : VALUE := 51;        
/*52*/ BIGDATA_ID_SEND_SENSOR_CLOSE_05                        : VALUE := 52;         
/*53*/ BIGDATA_ID_SEND_SENSOR_OPEN_06                         : VALUE := 53;         
/*54*/ BIGDATA_ID_SEND_SENSOR_OPEN_07                         : VALUE := 54;          
/*55*/ BIGDATA_ID_SEND_SENSOR_OPEN_08                         : VALUE := 55;          
/*56*/ BIGDATA_ID_SEND_SENSOR_OPEN_09                         : VALUE := 56;           
/*57*/ BIGDATA_ID_SEND_SENSOR_OPEN_10                         : VALUE := 57;        
/*58*/ BIGDATA_ID_SEND_REQUEST_INIT_GETPARAMETERDUMP          : VALUE := 58;              
/*59*/ BIGDATA_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP           : VALUE := 59;              
/*60*/ BIGDATA_ID_SEND_REQUEST_CONT_GETPARAMETERDUMP          : VALUE := 60;            
/*61*/ BIGDATA_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP           : VALUE := 61;      
/*62*/ BIGDATA_ID_SEND_REQUEST_INIT_SETPARAMETERDUMP          : VALUE := 62;          
/*63*/ BIGDATA_ID_SEND_REQUEST_CONT_SETPARAMETERDUMP          : VALUE := 63;          
/*64*/ BIGDATA_ID_SEND_EXTERNAL_SERVICE_CALL                  : VALUE := 64;   
/*65*/ BIGDATA_ID_SEND_PC_LOGINLOGOUT                         : VALUE := 65;   
/*66*/ BIGDATA_ID_SEND_GET_COMPLETE_PARAMETERDUMP             : VALUE := 66;   

/*100*/ EX_ID_SEND_NO                                         : VALUE := 100;  
/*101*/ EX_ID_SEND_OPERATOR_ID_LOGIN                          : VALUE := 101;         //Operator ID Login  
/*102*/ EX_ID_SEND_OPERATOR_ID_LOGOUT                         : VALUE := 102;         //Operator ID Logout
/*103*/ EX_ID_SEND_POWER_ON                                   : VALUE := 103;         //Machine ID / Power On
/*104*/ EX_ID_SEND_GETPARAMETER_ANSWER                        : VALUE := 104;//works         //GetParameter Answer
/*105*/ EX_ID_SEND_SEW_INFORMATION                            : VALUE := 105;         //Sew Information
/*106*/ EX_ID_SEND_SERVICE_CALL                               : VALUE := 106;         //Service Call
/*107*/ EX_ID_SEND_GETPARAMETER                               : VALUE := 107;//works         //GetParameter
/*108*/ EX_ID_SEND_SETPARAMETER                               : VALUE := 108;//works         //SetParameter
/*109*/ EX_ID_SEND_OPERATOR_ID_ANSWER                         : VALUE := 109;         //Operator ID answer
/*110*/ EX_ID_SEND_ACK_TO_CONTROL_BOX                         : VALUE := 110;         //Acknowledge to control box
/*111*/ EX_ID_SEND_RESETSTATUS                                : VALUE := 111;         //ResetStatus
/*112*/ EX_ID_SEND_RESETSERVICECOUNTER                        : VALUE := 112;//test         //ResetServiceCounter
/*113*/ EX_ID_SEND_GETSERVICECOUNTER                          : VALUE := 113;         //GetServiceCounter
/*114*/ EX_ID_SEND_GETSTATUS                                  : VALUE := 114;         //GetStatus
/*115*/ EX_ID_SEND_RESETPIECECOUNTER                          : VALUE := 115;//works         //ResetPieceCounter
/*116*/ EX_ID_SEND_GETPIECECOUNTER                            : VALUE := 116;//works         //GetPieceCounter
/*117*/ EX_ID_SEND_MESSAGEMODESETUP                           : VALUE := 117;         //MessageModeSetup
/*118*/ EX_ID_SEND_ACK_TO_PC                                  : VALUE := 118;//works         //Acknowledge to PC
/*119*/ EX_ID_SEND_GETSTATUS_ANSWER                           : VALUE := 119;         //GetStatus answer
/*120*/ EX_ID_SEND_PIECECOUNTER_READY_0                       : VALUE := 120;         //PieceCounterReady
/*121*/ EX_ID_SEND_SERVICECOUNTER_READY_0                     : VALUE := 121;         //ServiceCounter1Ready
/*122*/ EX_ID_SEND_SERVICECOUNTER_READY_1                     : VALUE := 122;         //ServiceCounter2Ready
/*123*/ EX_ID_SEND_SERVICECOUNTER_READY_2                     : VALUE := 123;         //ServiceCounter3Ready
/*124*/ EX_ID_SEND_SERVICECOUNTER_READY_3                     : VALUE := 124;         //ServiceCounter4Ready
/*125*/ EX_ID_SEND_SERVICECOUNTER_READY_4                     : VALUE := 125;         //ServiceCounter5Ready
/*126*/ EX_ID_SEND_PIECECOUNTER_VALUE_0                       : VALUE := 126;//works         //GetPieceCounter answer
/*127*/ EX_ID_SEND_DISABLEOUTPUT                              : VALUE := 127;         //DisableOutput
/*128*/ EX_ID_SEND_SETOUTPUT                                  : VALUE := 128;         //SetOutput
/*129*/ EX_ID_SEND_SETPROGRAMMINGMODE                         : VALUE := 129;         //SetProgrammingMode
/*130*/ EX_ID_SEND_GET_CONTROLBOX_STATUS                      : VALUE := 130;         //GetControlBoxStatus
/*131*/ EX_ID_SEND_SERVICECOUNTER_VALUE_0                     : VALUE := 131;         //Get ServiceCounter1 answer
/*132*/ EX_ID_SEND_SERVICECOUNTER_VALUE_1                     : VALUE := 132;         //Get ServiceCounter2 answer
/*133*/ EX_ID_SEND_SERVICECOUNTER_VALUE_2                     : VALUE := 133;         //Get ServiceCounter3 answer
/*134*/ EX_ID_SEND_SERVICECOUNTER_VALUE_3                     : VALUE := 134;         //Get ServiceCounter4 answer
/*135*/ EX_ID_SEND_SERVICECOUNTER_VALUE_4                     : VALUE := 135;         //Get ServiceCounter5 answer
/*136*/ EX_ID_SEND_GET_CONTROLBOX_STATUS_ANSWER               : VALUE := 136;         //GetControlBoxStatus answer
/*137*/ EX_ID_SEND_LOCKCONTROLBOX                             : VALUE := 137;         //LockControlBox
/*138*/ EX_ID_SEND_RESTARTCONTROLBOX                          : VALUE := 138;         //RestartControlBox
/*139*/ EX_ID_SEND_SERVICECALL_ACKNOWLEDGE                    : VALUE := 139;         //ServiceCall Acknowledge
/*140*/ EX_ID_SEND_RUNBLOCKAGE                                : VALUE := 140;         //RunBlockage
/*141*/ EX_ID_SEND_POWER_OFF                                  : VALUE := 141;         //Machine ID / Power Off
/*142*/ EX_ID_SEND_REQUST_POWER_ON                            : VALUE := 142;         //Get Machine ID / Power On
/*143*/ EX_ID_SEND_SHORT_SEW_INFORMATION                      : VALUE := 143;         //Short Sew Information 
/*144*/ EX_ID_SEND_WATCHDOGMESSAGE                            : VALUE := 144;         //
/*145*/ EX_ID_SEND_ERROR_TO_PC                                : VALUE := 145;         //Error to PC
/*146*/ EX_ID_SEND_FREE2                                      : VALUE := 146;         //
/*147*/ EX_ID_SEND_ERROR_TO_CONTROL_BOX                       : VALUE := 147;         //Error to Control Box
/*148*/ EX_ID_SEND_SENSOR_CLOSE_01                            : VALUE := 148;         //SensorClose01 to PC
/*149*/ EX_ID_SEND_SENSOR_CLOSE_02                            : VALUE := 149;         //SensorClose02 to PC
/*150*/ EX_ID_SEND_SENSOR_CLOSE_03                            : VALUE := 150;         //SensorClose03 to PC
/*151*/ EX_ID_SEND_SENSOR_CLOSE_04                            : VALUE := 151;         //SensorClose04 to PC
/*152*/ EX_ID_SEND_SENSOR_CLOSE_05                            : VALUE := 152;         //SensorClose05 to PC
/*153*/ EX_ID_SEND_SENSOR_OPEN_06                             : VALUE := 153;         //SensorClose06 to PC
/*154*/ EX_ID_SEND_SENSOR_OPEN_07                             : VALUE := 154;         //SensorClose07 to PC
/*155*/ EX_ID_SEND_SENSOR_OPEN_08                             : VALUE := 155;         //SensorClose08 to PC
/*156*/ EX_ID_SEND_SENSOR_OPEN_09                             : VALUE := 156;         //SensorClose09 to PC
/*157*/ EX_ID_SEND_SENSOR_OPEN_10                             : VALUE := 157;         //SensorClose10 to PC
/*158*/ EX_ID_SEND_REQUEST_INIT_GETPARAMETERDUMP              : VALUE := 158;//works               
/*159*/ EX_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP               : VALUE := 159;//works          
/*160*/ EX_ID_SEND_REQUEST_CONT_GETPARAMETERDUMP              : VALUE := 160;//works               
/*161*/ EX_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP               : VALUE := 161;//works         
/*162*/ EX_ID_SEND_REQUEST_INIT_SETPARAMETERDUMP              : VALUE := 162;//not needed           
/*163*/ EX_ID_SEND_REQUEST_CONT_SETPARAMETERDUMP              : VALUE := 163;//works                    
/*164*/ EX_ID_SEND_EXTERNAL_SERVICE_CALL                      : VALUE := 164;//test 
/*165*/ EX_ID_SEND_PC_LOGINLOGOUT                             : VALUE := 165; 
/*166*/ EX_ID_SEND_GET_COMPLETE_PARAMETERDUMP                 : VALUE := 166; 
   
   
   
//Dongle commands   
/*101*/ DONGLE_ID_SEND_DETECT_REQUEST                         : VALUE := 101;                 
/*102*/ DONGLE_ID_SEND_DETECT_ANSWER_TO_CONTROL_BOX           : VALUE := 102;       
/*103*/ DONGLE_ID_SEND_DETECT_ENABLE                          : VALUE := 103;              
/*104*/ DONGLE_ID_SEND_ERROR_TO_CONTROL_BOX                   : VALUE := 104;               
/*105*/ DONGLE_ID_SEND_RESTART                                : VALUE := 105;                          
/*106*/ DONGLE_ID_SEND_DELETE_BLID                            : VALUE := 106;                     
/*107*/ DONGLE_ID_SEND_GETVERSIONID_REQUEST                   : VALUE := 107;               
/*108*/ DONGLE_ID_SEND_GETVERSIONID_ANSWER_TO_CONTROL_BOX     : VALUE := 108;   
/*109*/ DONGLE_ID_SEND_ACK_TO_CONTROL_BOX                     : VALUE := 109;                 
   
     
//Values for Benutzer_Ebene
STATUS_MECHANIC                                               : VALUE := 1;
STATUS_OPERATOR                                               : VALUE := 2;


NO_EX         : VALUE := 0;
WITH_EX       : VALUE := 1;

//Values for PARA_SEAM_END_INPUT
SEAMEND_INV_IN01                                    : VALUE := 1;
SEAMEND_INV_IN02                                    : VALUE := 2;
SEAMEND_INV_IN03                                    : VALUE := 3;
SEAMEND_INV_IN04                                    : VALUE := 4;
SEAMEND_INV_IN05                                    : VALUE := 5;
SEAMEND_INV_IN06                                    : VALUE := 6;
SEAMEND_INV_IN07                                    : VALUE := 7;
SEAMEND_INV_IN08                                    : VALUE := 8;
SEAMEND_INV_IN09                                    : VALUE := 9;
SEAMEND_INV_IN10                                    : VALUE := 10;
SEAMEND_INV_IN11                                    : VALUE := 11;
SEAMEND_INV_IN12                                    : VALUE := 12;
SEAMEND_INV_LSM                                     : VALUE := 13;
SEAMEND_IN01                                        : VALUE := 21;
SEAMEND_IN02                                        : VALUE := 22;
SEAMEND_IN03                                        : VALUE := 23;
SEAMEND_IN04                                        : VALUE := 24;
SEAMEND_IN05                                        : VALUE := 25;
SEAMEND_IN06                                        : VALUE := 26;
SEAMEND_IN07                                        : VALUE := 27;
SEAMEND_IN08                                        : VALUE := 28;
SEAMEND_IN09                                        : VALUE := 29;
SEAMEND_IN10                                        : VALUE := 30;
SEAMEND_IN11                                        : VALUE := 31;
SEAMEND_IN12                                        : VALUE := 32;
SEAMEND_LSM                                         : VALUE := 33;

//Values for SetSystemInfo()
/*37*/ SYSTEMINFO_StringMessageMode                 : VALUE := 37;
/*38*/ SYSTEMINFO_Dongle_Init                       : VALUE := 38;
/*39*/ SYSTEMINFO_Dongle_Get                        : VALUE := 39;
/*40*/ SYSTEMINFO_Dongle_Val1                       : VALUE := 40;
/*41*/ SYSTEMINFO_Dongle_Val2                       : VALUE := 41;
/*42*/ SYSTEMINFO_Dongle_Val3                       : VALUE := 42;
/*43*/ SYSTEMINFO_Dongle_Val4                       : VALUE := 43;
/*44*/ SYSTEMINFO_BigData_SoftwareEnable            : VALUE := 44;
/*45*/ SYSTEMINFO_BigData_DongleEnable              : VALUE := 45;
/*46*/ SYSTEMINFO_BigData_GetAmountParameterList    : VALUE := 46;
/*47*/ SYSTEMINFO_pardef_LoadMode                   : VALUE := 47;
/*48*/ SYSTEMINFO_len_pardef_cmn                    : VALUE := 48;
/*49*/ SYSTEMINFO_BigData_FosPostLoadPara           : VALUE := 49;
/*50*/ SYSTEMINFO_BigData_FosPreLoadPara            : VALUE := 50;
/*51*/ SYSTEMINFO_GetParaNumFrompardefIndex         : VALUE := 51;
/*52*/ SYSTEMINFO_strlen_rxd_buffer                 : VALUE := 52;
/*53*/ SYSTEMINFO_strlen_RxBuffer                   : VALUE := 53; 
/*54*/ SYSTEMINFO_RxBuffer                          : VALUE := 54;    



//Values for SetMessageKeywords()
KEYWORD_COMMAND                                     : VALUE := 1;
KEYWORD_REQUEST                                     : VALUE := 2;
KEYWORD_RESPONSE                                    : VALUE := 3;
KEYWORD_DONGLE                                      : VALUE := 4;
KEYWORD_EXCOMMAND                                   : VALUE := 5;
KEYWORD_EXREQUEST                                   : VALUE := 6;
KEYWORD_EXRESPONSE                                  : VALUE := 7;


//Values for BigData_Ack_Mode
/*00*/ BIGDATA_ACK_MODE_NO                          : VALUE := 0;
/*01*/ BIGDATA_ACK_MODE_NO_ACK                      : VALUE := 1;
/*02*/ BIGDATA_ACK_MODE_WITH_ACK                    : VALUE := 2;

//Values for BigData_DataMode
/*01*/ BIGDATA_MODE_1                               : VALUE := 1;
/*02*/ BIGDATA_MODE_2                               : VALUE := 2;
/*03*/ BIGDATA_MODE_3                               : VALUE := 3;
/*04*/ BIGDATA_MODE_4                               : VALUE := 4;
/*05*/ BIGDATA_MODE_5                               : VALUE := 5;
/*06*/ BIGDATA_MODE_6                               : VALUE := 6;
/*07*/ BIGDATA_MODE_7                               : VALUE := 7;
/*08*/ BIGDATA_MODE_8                               : VALUE := 8;
/*09*/ BIGDATA_MODE_9                               : VALUE := 9;
/*10*/ BIGDATA_MODE_10                              : VALUE := 10;
/*11*/ BIGDATA_MODE_11                              : VALUE := 11;
/*12*/ BIGDATA_MODE_12                              : VALUE := 12;
/*13*/ BIGDATA_MODE_13                              : VALUE := 13;
/*14*/ BIGDATA_MODE_14                              : VALUE := 14;
/*15*/ BIGDATA_MODE_15                              : VALUE := 15;
/*16*/ BIGDATA_MODE_16                              : VALUE := 16;
/*17*/ BIGDATA_MODE_17                              : VALUE := 17;
/*18*/ BIGDATA_MODE_18                              : VALUE := 18;
/*19*/ BIGDATA_MODE_19                              : VALUE := 19;
/*20*/ BIGDATA_MODE_20                              : VALUE := 20;

//Values for BigData_Error
/*00*/ BIGDATA_ERROR_NO                             : VALUE := 0;
/*01*/ BIGDATA_ERROR_NO_RAM                         : VALUE := 1;
/*02*/ BIGDATA_ERROR_TX_TIMEOUT                     : VALUE := 2;
/*03*/ BIGDATA_ERROR_RX_UNKNOWN_COMMAND             : VALUE := 3;
/*04*/ BIGDATA_ERROR_TX_BUFFER_OVERFLOW             : VALUE := 4;
/*05*/ BIGDATA_ERROR_NO_MEMORY                      : VALUE := 5;
/*06*/ BIGDATA_ERROR_PARAMETER_SIZE                 : VALUE := 6;
/*07*/ BIGDATA_ERROR_NOT_ENABLED                    : VALUE := 7;

//Values for SetAllDisplayText()
SADT_INIT_SECTION                                   : VALUE := 1;
SADT_INIT_BARCODE                                   : VALUE := 2;
SADT_READY_BIGDATA                                  : VALUE := 3;
SADT_DEBUG                                          : VALUE := 4;
SADT_ERROR_SF1                                      : VALUE := 5;
SADT_ERROR_SF2                                      : VALUE := 6;
SADT_ERROR_SF3                                      : VALUE := 7;
SADT_ERROR_A19                                      : VALUE := 8;
SADT_TX_BUFFER                                      : VALUE := 9;
SADT_INIT_LOGIN                                     : VALUE := 10;
SADT_INIT_SERVICECALL                               : VALUE := 11;
SADT_ERROR_DONGLE                                   : VALUE := 12;

//Values for SetAllDisplayText()
TEXT_INIT_SECTION                                   : STRING := "init bigdata";
TEXT_INIT_BARCODE                                   : STRING := "init barcode";
TEXT_READY_BIGDATA                                  : STRING := "rdy bigdata";
TEXT_DEBUG                                          : STRING := "    debug";
TEXT_SF1                                            : STRING := "SF1";
TEXT_SF2                                            : STRING := "SF2";
TEXT_SF3                                            : STRING := "SF3";
TEXT_A19                                            : STRING := "A19";
TEXT_ERR                                            : STRING := "Err";
TEXT_DONGLE                                         : STRING := "DON ERROR";

INDEX_SeamTime                                      : VALUE := 1;
INDEX_StitchCount                                   : VALUE := 2;
INDEX_AverageSpeed                                  : VALUE := 3;
INDEX_RunTime                                       : VALUE := 4;
INDEX_StopTime                                      : VALUE := 5;
//INDEX_TimeBetweenSeams                              : VALUE := 6;

//Values for ActualDisplay
DISPLAY_INIT_SEWING                                 : VALUE := 1;
DISPLAY_INIT_LOGIN                                  : VALUE := 2;
DISPLAY_INIT_SERVICECALL                            : VALUE := 3;
DISPLAY_CONT_SEWING                                 : VALUE := 4;
DISPLAY_CONT_LOGIN                                  : VALUE := 5;
DISPLAY_CONT_SERVICECALL                            : VALUE := 6;
DISPLAY_WAIT_LOGIN                                  : VALUE := 7;
DISPLAY_INIT_CALL_SET                               : VALUE := 8;
DISPLAY_CONT_CALL_SET                               : VALUE := 9;
DISPLAY_INIT_CALL_OK                                : VALUE := 10;
DISPLAY_CONT_CALL_OK                                : VALUE := 11;

SERVICECOUNTER_MODE_TIMER                           : VALUE := 1;
SERVICECOUNTER_MODE_COUNTER                         : VALUE := 2;


//-------------------------------------------------------------------------------------------------------
// Parameter 6xx
//-------------------------------------------------------------------------------------------------------
PARA_PRESETPARAMETER                                  : VALUE := 601;
//PARA_DEBUG_ACTIVE                                     : VALUE := 661;
//PARA_DEBUG_SIGNALS_ACTIVE                             : VALUE := 662;
//PARA_SHOW_CYCLE_TIME                                  : VALUE := 663;


//-------------------------------------------------------------------------------------------------------
// Parameter 7xx
//-------------------------------------------------------------------------------------------------------


PARA_SERVICECOUNTER_MODE_1                       : VALUE := 765;
PARA_SERVICECOUNTER_MODE_2                       : VALUE := 766;
PARA_SERVICECOUNTER_MODE_3                       : VALUE := 767;
PARA_SERVICECOUNTER_MODE_4                       : VALUE := 768;
PARA_SERVICECOUNTER_MODE_5                       : VALUE := 769;

//PARA_EFKA_PROJEKTNUMMER                          : VALUE := 777;//EFKA versions-number
//PARA_VERSION                                     : VALUE := 779;//Program-Version

PARA_SEAM_END_INPUT                              : VALUE := 780;

PARA_SERVICECOUNTER_STARTWERT_1                  : VALUE := 781;
PARA_SERVICECOUNTER_STARTWERT_2                  : VALUE := 782;
PARA_SERVICECOUNTER_STARTWERT_3                  : VALUE := 783;
PARA_SERVICECOUNTER_STARTWERT_4                  : VALUE := 784;
PARA_SERVICECOUNTER_STARTWERT_5                  : VALUE := 785;

PARA_PIECECOUNTER_COUNT_MAX                      : VALUE := 786;
PARA_PIECECOUNTER_COUNT_Act                      : VALUE := 787;

PARA_SERVICECOUNTER_ACT_1                        : VALUE := 788;
PARA_SERVICECOUNTER_ACT_2                        : VALUE := 789;
PARA_SERVICECOUNTER_ACT_3                        : VALUE := 790;
PARA_SERVICECOUNTER_ACT_4                        : VALUE := 791;
PARA_SERVICECOUNTER_ACT_5                        : VALUE := 792;

PARA_SERVICECOUNTER_SEC_1                        : VALUE := 793;
PARA_SERVICECOUNTER_SEC_2                        : VALUE := 794;
PARA_SERVICECOUNTER_SEC_3                        : VALUE := 795;
PARA_SERVICECOUNTER_SEC_4                        : VALUE := 796;
PARA_SERVICECOUNTER_SEC_5                        : VALUE := 797;

PARA_TASKTIME                                    : VALUE := 798;
PARA_MACHINE_ID1                                 : VALUE := 799;

//-------------------------------------------------------------------------------------------------------
// Parameter 9xx
//-------------------------------------------------------------------------------------------------------

PARA_BIGDATA_MODE                                 : VALUE := 906;
PARA_MACHINE_ID2                                  : VALUE := 907;

//Values for BigDataDataDump_Typ
DDT_NO                                            : VALUE := 0;
DDT_PARAMETER                                     : VALUE := 1; 

DPT_NO                                            : VALUE := 0;
DPT_NOT_USED                                      : VALUE := 1;
DPT_PARAMETERLIST                                 : VALUE := 2;
DPT_TEXTLIST                                      : VALUE := 3;

//Values for AppendSectionStringToSendString
SEAM_INFO_S0                                      : VALUE := 0;
//No other value allowed all values 1,2,3,..are used for section info!!!

//Values for AppendStringToSendString
SEAM_STRING_TEMP1                                 : VALUE := 1;
DATADUMP_STRING_ID                                : VALUE := 2;
DATADUMP_STRING_SN                                : VALUE := 3;
DATADUMP_STRING_LFD                               : VALUE := 4;
STRING_SIGNDAT_PARAM                              : VALUE := 5;

BIGDATA_TX_REPEATTIME                             : VALUE := 2000;
//BIGDATA_TX_COMPILER_REPEATTIME                    : VALUE := 2000;
BIGDATA_TX_REPEATCOUNT                            : VALUE := 5;

//Values for Status_Motor_On_Task & Status_Power_On_Task
//TASK_STATUS_REQUEST_STOP                          : VALUE := 2;
//TASK_STATUS_IS_STOPPED                            : VALUE := 1;
//TASK_STATUS_RUN                                   : VALUE := 0;


//Arrays
//ARRAY_MAX_INDEX 20
ARRAY_TWO_OFFSET                                 : VALUE := 10;

ARRAY_SECTION_SEWING_TIME                        : VALUE := 1;
ARRAY_SECTION_STITCHES                           : VALUE := 2;
ARRAY_SECTION_AVERAGE_SPEED                      : VALUE := 3;
ARRAY_SECTION_RUN_TIME                           : VALUE := 4;
ARRAY_SECTION_STOP_TIME                          : VALUE := 5;
ARRAY_SECTION_INPUT_SEWING                       : VALUE := 6;
ARRAY_SECTION_OUTPUT_SEWING                      : VALUE := 7;
ARRAY_SECTION_INPUT_STOP                         : VALUE := 8;
ARRAY_SECTION_OUTPUT_STOP                        : VALUE := 9;

ARRAY_TWO_SECTION_SEWING_TIME                        : VALUE := 11;
ARRAY_TWO_SECTION_STITCHES                           : VALUE := 12;
ARRAY_TWO_SECTION_AVERAGE_SPEED                      : VALUE := 13;
ARRAY_TWO_SECTION_RUN_TIME                           : VALUE := 14;
ARRAY_TWO_SECTION_STOP_TIME                          : VALUE := 15;
ARRAY_TWO_SECTION_INPUT_SEWING                       : VALUE := 16;
ARRAY_TWO_SECTION_OUTPUT_SEWING                      : VALUE := 17;
ARRAY_TWO_SECTION_INPUT_STOP                         : VALUE := 18;
ARRAY_TWO_SECTION_OUTPUT_STOP                        : VALUE := 19;


MAX_SECTIONS                                     : VALUE := 35;//Maximale Anzahl von Stops 35 =-> max34

ARRAY_TYP_LONG                                   : VALUE := 4;


SIZE_STRING_TEMP                                 : VALUE := 200;

/*05*/ SF_COPY_USERSTRING_TO_BIGDATA_TXBUFFER    : VALUE := 5;
/*06*/ SF_SEND_BIGDATA_TXBUFFER                  : VALUE := 6;
/*07*/ SF_CREATE_BIGDATA_TXBUFFER                : VALUE := 7;
/*12*/ SF_DONGLE_CHECK                           : VALUE := 12;


//values for StringMessageMode
MM_DONGLE                                        : VALUE := 1;
MM_BIGDATA                                       : VALUE := 0;


VAR
BigDataDataDump_Typ                              : VALUE := 0;
BigDataServiceCall_Nr                            : VALUE := 0;
BigDataServiceCall_Status                        : VALUE := 0;
ServiceCounter_ExecuteCount                      : VALUE := 0;
ServiceCounter_ExecuteTime                       : VALUE := 0;

testcounter1 : VALUE;//can be deleted

Array_Section_Get_Index                             : VALUE := 0;
Array_Section_Set_Index                             : VALUE := 0;
//bDongleDetection                                    : BIT := FALSE;
bCreateDisplayActiv                                 : BIT := FALSE;
Val_DEBUG_ACTIVE                                    : BIT := FALSE;
//Val_DEBUG_SIGNALS_ACTIVE                             : BIT := FALSE;
//SendNow                                              : BIT := FALSE;
Valsprintf : VALUE;
DataDump_len_pardef_cmn                          : VALUE := 0;
DataDump_IndexOfData                             : VALUE := 0;
DataDump_AppendControlBoxInfo                    : VALUE := 0;
DataDump_IndexParameterText                      : VALUE := 0;
DataDump_AmoutOfData                             : VALUE := 0;
DataDump_MerkerParalist                          : VALUE := 0;
DataDump_OrderOfData                             : VALUE := 0;
DataDump_paranum                                 : VALUE := 0;
DataDump_TempVal1                                : VALUE := 0;
Dongle_Val1                                      : VALUE := 0;
Dongle_Val2                                      : VALUE := 0;
Dongle_Val3                                      : VALUE := 0;
Dongle_Val4                                      : VALUE := 0;
Dongle_Val5                                      : VALUE := 0;
Dongle_Val6                                      : VALUE := 0;
Dongle_Val7                                      : VALUE := 0;
Dongle_Val8                                      : VALUE := 0;
Dongle_Val9                                      : VALUE := 0;
Dongle_Typ                                       : VALUE := 0;
//CycleCounter                                     : VALUE := 0;
//Ablauf_SendStringTest                            : VALUE := 0;
dummy                                            : VALUE := 0;
StringMessageMode                                : VALUE := 0;//dongle = 1 else = 0
Ablauf_BigData_Cont                              : VALUE := 0;
ServiceCounter_ID                                : VALUE := 0;
ServiceCounter_MODE                              : VALUE := 0;
ServiceCounter_Startwert_Temp                    : VALUE := 0;
ServiceCounter_Startwert_1                       : VALUE := 0;
ServiceCounter_Startwert_2                       : VALUE := 0;
ServiceCounter_Startwert_3                       : VALUE := 0;
ServiceCounter_Startwert_4                       : VALUE := 0;
ServiceCounter_Startwert_5                       : VALUE := 0;
ServiceCounter_Mode_1                            : VALUE := 0;
ServiceCounter_Mode_2                            : VALUE := 0;
ServiceCounter_Mode_3                            : VALUE := 0;
ServiceCounter_Mode_4                            : VALUE := 0;
ServiceCounter_Mode_5                            : VALUE := 0;
ServiceCounter_Act_1                             : VALUE := 0;
ServiceCounter_Act_2                             : VALUE := 0;
ServiceCounter_Act_3                             : VALUE := 0;
ServiceCounter_Act_4                             : VALUE := 0;
ServiceCounter_Act_5                             : VALUE := 0;
ActualDisplay                                    : VALUE := 0;
Val_TASKTIME                                     : VALUE := 0;
//AVTSS_Len1                                       : VALUE := 0;
//AVTSS_Len2                                       : VALUE := 0;
Section_Value                                    : VALUE := 0;
Total_Value                                      : VALUE := 0;
TotalTemp_Value                                  : VALUE := 0;
SequenzCounter                                   : VALUE := 0;
GetSetParameterValue                             : VALUE := 0;
GetSetParameterNumber                            : VALUE := 0;
RxMessageCounter                                 : VALUE := 0;
Benutzer_Ebene                                   : VALUE := 0;
TempVal1                                         : VALUE := 0;
TempVal2                                         : VALUE := 0;
TempVal3                                         : VALUE := 0;
TempVal4                                         : VALUE := 0;
TempVal5                                         : VALUE := 0;
Anzeige_Naht_Text_neu                            : VALUE := 0;
Anzeige_Naht_Text_alt                            : VALUE := 0;
Time_Tx_Repeat                                   : VALUE := 0;
Actual_Tx_Info                                   : VALUE := 0;
Actual_Tx_MessageCounter                         : VALUE := 0;
Actual_Rx_UniqueIdentifier                       : VALUE := 66;
BigData_TxD_Counter                              : VALUE := 0;
BigData_DataMode                                 : VALUE := 0;
BigData_Ack_Mode                                 : VALUE := 0;
BigData_PowerOn_Message                          : VALUE := 0;
BigData_TxD_RepeatTime                           : VALUE := 0;
BigData_Error                                    : VALUE := 0;
BigData_MessageKeywords                          : VALUE := 0;
BigData_SewInformation                           : VALUE := 0;
BigData_NoACKRunBlockage                         : VALUE := 0;
BigData_MessageModeWithMessageCounter            : VALUE := 0;
BigData_RepeatMaxCount                           : VALUE := 0;
BigData_UserLoginRequired                        : VALUE := 0;
BigData_WatchdogTime                             : VALUE := 0;
BigData_TxD_RepeatCounter                        : VALUE := 0;
BigData_SendSewInformationWhenPedal0             : BIT := FALSE;
BigData_Flag_SendSewInformationWhenPedal0        : BIT := FALSE;

 Disable_PieceCounter                            : BIT := FALSE;
 Disable_ServiceTimerCounter                     : BIT := FALSE;
//SendFastSeamEnd                                  : BIT := FALSE;
DoubleSendBuffer                                 : BIT := FALSE;
//BigData_SendNoBackTackInformation                : VALUE := 0;
Rx_Message_Counter                               : VALUE := 0;
Rx_Message_ID                                    : VALUE := 0;
Rx_Answer_Message_ID                             : VALUE := 0;
Debug_TxRx_String_Pos_X                          : VALUE := 0;
WaitForAck                                       : BIT := FALSE;
ArrowToggleBit                                   : BIT := FALSE;
CounterInfo                                      : VALUE := 0;

//TotalSeam_TimeBetweenSeams                       : VALUE := 0;
//SequenzSeam_StopCount                            : VALUE := 0;
PieceCounter_ID                                  : VALUE := 0;
PieceCounter_MODE                                : VALUE := 0;
PieceCounter_COUNT_MAX                           : VALUE := 0;
PieceCounter_COUNT_Act                           : VALUE := 0;
//Section_Time                                     : VALUE := 0;
//Section_StitchCount                              : VALUE := 0;
//Section_AverageSpeed                             : VALUE := 0;
//Section_RunTime                                  : VALUE := 0;
//Section_StopTime                                 : VALUE := 0;
//Section_MerkerStitchCount                        : VALUE := 0;
//Section_GesamtStitchCount                        : VALUE := 0;
Eval_Minute_Counter                              : VALUE := 0;
//Power_On_Minute_Counter                          : VALUE := 0;
//Power_On_Hour_Counter                            : VALUE := 0;
//Motor_On_Second_Counter                          : VALUE := 0;
//Motor_On_Minute_Counter                          : VALUE := 0;
//Motor_On_Hour_Counter                            : VALUE := 0;
Seam_Time_Second_Counter                         : VALUE := 0;
Seam_Stitch_Counter                              : VALUE := 0;
Seam_Stopp_Counter                               : VALUE := 0;
VAL_USER_ID_1                                    : VALUE := 0;
VAL_USER_ID_2                                    : VALUE := 0;
VAL_USER_ID_3                                    : VALUE := 0;
VAL_SERVICE_NUMBER                               : VALUE := 0;
VAL_PARA_MACHINE_ID                              : VALUE := 0;
Login_Value                                      : VALUE := 0;
Login_Stelle                                     : VALUE := 0;
Wait_Login                                       : BIT := FALSE;
Logout_Aktiv                                     : BIT := FALSE;
Power_On_Message_Aktiv                           : BIT := FALSE;
Flag_Merker_SeamEndInput                         : BIT := FALSE;
Value_SEAM_END_INPUT                             : VALUE := 0;
Ablauf_Menu                                      : VALUE := 0;
PowerOnRunBlockage                               : VALUE := 0;
STRINGLENGTH_BigDataString                       : VALUE := 0;
STRINGSTATUS_BigDataString                       : VALUE := 0;
Array_TxSend_01                                  : VALUE := 0;
Array_TxSend_02                                  : VALUE := 0;
Array_TxSend_03                                  : VALUE := 0;
Array_TxSend_04                                  : VALUE := 0;
Array_TxSend_05                                  : VALUE := 0;
Array_TxSend_06                                  : VALUE := 0;
Array_TxSend_07                                  : VALUE := 0;
Array_TxSend_08                                  : VALUE := 0;
Array_TxSend_09                                  : VALUE := 0;
Array_TxSend_10                                  : VALUE := 0;
BigData_TxManager_ActualFillBuffer               : VALUE := 0;
BigData_TxManager_ActualSendBuffer               : VALUE := 0;
BigData_SendData                                 : VALUE := 0;
MMISSF_RetVal_H                                  : VALUE := 0;
MMISSF_RetVal_L                                  : VALUE := 0;
Counter_SHOW_CYCLE_TIME                          : VALUE := 0;

flag_BigData_SetEnableFpPedal                    : BIT := FALSE;
flag_BigData_SetDisablePedal                     : BIT := FALSE;
flag_BigData_SetRunBlockage                      : BIT := FALSE;
flag_BigData_SetStopNoPosition                   : BIT := FALSE;
flag_Main_SetEnableFpPedal                       : BIT := FALSE;
flag_Main_SetDisablePedal                        : BIT := FALSE;
flag_Main_SetRunBlockage                         : BIT := FALSE;
flag_Main_SetStopNoPosition                      : BIT := FALSE;

BigData_Connection_Lost                          : BIT := FALSE;
Status_Connection_Lost                           : VALUE := 0;
//Time_SewInformation                              : VALUE := 0;
//Time_SendSewInformation                          : VALUE := 0;
//Time_InformationWasSend                          : VALUE := 0;
//Time_StartNextSeam                               : VALUE := 0;
//Time_InitAfterSeam                               : VALUE := 0;

ALIAS

STRING_CODE                                      : String38;
STRING_CODE2                                     : String39;
STRING_TEMP1                                     : String40;
STRING_Tx                                        : String41;
STRING_BARCODE                                   : String43;
STRING_NAME_1                                    : String44;
STRING_NAME_2                                    : String45;
STRING_NAME_3                                    : String46;
STRING_NAME_4                                    : String47;
STRING_BigDataString                             : String48;//must be same number here  BIGDATASTRINGNUMBER !!!!!!!!
STRING_TEMP2                                     : String49;
STRING_OPERATOR                                  : String50;

DONGLE_DEVICE_ADRESS                             : Device1;//dummy adress is F9
PC_DEVICE_ADRESS                                 : Device2;

TIMER_SERVICECALLAUTOSEND                         : Timer20;//
TIMER_COLLECT_CYCLE                               : Timer21;//
TIMER_COLLECT_BETWEENSEAMS                        : Timer22;//
//TIMER_TESTDURATION                                : Timer23;//
TIMER_RUNBLOCKAGE                                : Timer24;//
TIMER_SHOW_CYCLE_TIME                            : Timer25;//
TIMER_TOGGLE                                     : Timer26;//Timer for ArrowToggle Testdisplay
TIMER_DONGLE                                     : Timer27;//Timer for Dongle Timeouts
TIMER_WAITMS                                     : Timer28;//Timer for Compiler program / small loops
TIMER_MOTORSTOP                                  : Timer29;//Timer for colltect Motor RUN/STOP time
TIMER_TX                                         : Timer30;//Timer for Tx message: after this time without ACk the message will be repeated
TIMER_WATCHDOGMESSAGE                            : Timer31;//Timer for Watchdog/KeepAlive message: after this time without any communication a message will be send to tell the server that control box is still ON

STITCHCOUNTER_SEAM                               : Stitchcounter31;





//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendSoftwareVersionToSendString();
PROCEDURE Send_Infos_TO_PC_test(Info : VALUE);
PROCEDURE Send_STRING_Tx();
PROCEDURE BigData_SendString(SATB_Wert : VALUE);

//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
PROCEDURE Fkt_While()
  WHILE (1)
  SetBeepShort();
  Waitms(1000);
  END_WHILE; 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//PROCEDURE ResetTestValTimer()
//IF (WITH_TIMECHECK) THEN
// ClearTimer(Timer5);
// SetTimer(Timer5,10000); 
//END_IF; 
//END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
FUNCTION IsSeamInputSet(ISIS : VALUE) : VALUE
IsSeamInputSet := 0;

IF (Value_SEAM_END_INPUT <> 0) THEN
 
 
 ISIS := 0;//Schaltzustand eingang
 SELECT (Value_SEAM_END_INPUT) OF
  CASE SEAMEND_INV_IN01:
   IF (NOT In1) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN02:
   IF (NOT In2) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN03:
   IF (NOT In3) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN04:
   IF (NOT In4) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN05:
   IF (NOT In5) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN06:
   IF (NOT In6) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN07:
   IF (NOT In7) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN08:
   IF (NOT In8) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN09:
   IF (NOT In9) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN10:
   IF (NOT In10) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN11:
   IF (NOT In11) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_IN12:
   IF (NOT In12) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_INV_LSM:
   IF (NOT LbIn) THEN
    ISIS := 1;
   END_IF;
 
  CASE SEAMEND_IN01:
   IF ( In1) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN02:
   IF ( In2) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN03:
   IF ( In3) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN04:
   IF ( In4) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN05:
   IF ( In5) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN06:
   IF ( In6) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN07:
   IF ( In7) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN08:
   IF ( In8) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN09:
   IF ( In9) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN10:
   IF ( In10) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN11:
   IF ( In11) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_IN12:
   IF ( In12) THEN
    ISIS := 1;
   END_IF;
  CASE SEAMEND_LSM:
   IF ( LbIn) THEN
    ISIS := 1;
   END_IF;
 END_SELECT;
 
 IF (ISIS = 1) THEN
  IF (NOT Flag_Merker_SeamEndInput) THEN
   IsSeamInputSet := 1;//Flanke erkannt
  END_IF;
  Flag_Merker_SeamEndInput := TRUE;
 ELSE 
  Flag_Merker_SeamEndInput := FALSE; 
 END_IF;

END_IF;
END_FUNCTION



//-------------------------------------------------------------------------------------------------------
PROCEDURE WatchdogTimerReset()
 IF (BigData_WatchdogTime) THEN
  ClearTimer(TIMER_WATCHDOGMESSAGE);
  SetTimer(TIMER_WATCHDOGMESSAGE,BigData_WatchdogTime);
 END_IF; 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SetAllDisplay_CreateDisplay()
 bCreateDisplayActiv := TRUE;
 IF (V900DeviceIsPresent) THEN
  ClearDisplay();
 ELSE
  CreateDisplay();
  LockVarioButton(VarioButtonP);
  LockVarioButton(VarioButtonE);
  LockVarioButton(VarioButtonPl);
  LockVarioButton(VarioButtonMi);
  LockVarioButton(VarioButtonF1);
  LockVarioButton(VarioButtonF2);
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SetAllDisplay_KillDisplay()
 bCreateDisplayActiv := FALSE;
 IF (V900DeviceIsPresent) THEN
  ClearDisplay();
 ELSE
  KillDisplay();
  UnLockVarioButton(VarioButtonP);
  UnLockVarioButton(VarioButtonE);
  UnLockVarioButton(VarioButtonPl);
  UnLockVarioButton(VarioButtonMi);
  //UnLockVarioButton(VarioButtonF1);
  //UnLockVarioButton(VarioButtonF2);
  LockVarioButton(VarioButtonF1);//Login/Logout
  LockVarioButton(VarioButtonF2);//ServiceCall
 END_IF;
 IF (BigData_Connection_Lost) THEN
  SetDisplayText(STRING_A23,3,0,0);
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Debug_Check_Pos_X_V900()
 Debug_TxRx_String_Pos_X := Debug_TxRx_String_Pos_X + 5;
 IF (Debug_TxRx_String_Pos_X >= 125) THEN
  ClearDisplay();
  Debug_TxRx_String_Pos_X := 0;
 END_IF;
END_PROCEDURE

////-------------------------------------------------------------------------------------------------------
PROCEDURE Debug_Add_Tx_String_V900()
 IF (V900DeviceIsPresent) THEN
  WriteText(0, Debug_TxRx_String_Pos_X,"Tx:");
  

    ValueToString(STRING_Tx,SignToValue(STRING_Tx, 12));
    WriteText(15,Debug_TxRx_String_Pos_X,STRING_Tx);
  Debug_Check_Pos_X_V900();
 END_IF;
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE ShowServiceCall()
 SetAllDisplay_CreateDisplay();
 SetDisplayText("Call",1,0,0);  
 IF (Login_Value) THEN
  ValueToString(STRING_CODE,Login_Value);
  IF (Login_Stelle < 4) THEN
   StringAppend(STRING_CODE,"_");
  END_IF;
 ELSE
  StringCopy(STRING_CODE,"_");
 END_IF; 
 //SetDisplayValue(Login_Value,2,0,0);
 SetDisplayText(STRING_CODE,2,0,0);
 //SetDisplayValue(Login_Stelle,3,0,0);
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE ShowUserValue()
 SetAllDisplay_CreateDisplay();
 SetDisplayText("OPID",1,0,0);  
 IF (Login_Value) THEN
  ValueToString(STRING_CODE,Login_Value);
  IF (Login_Stelle < 4) THEN
   StringAppend(STRING_CODE,"_");
  END_IF;
 ELSE
  StringCopy(STRING_CODE,"_");
 END_IF; 
 //SetDisplayValue(Login_Value,2,0,0);
 SetDisplayText(STRING_CODE,2,0,0);
 //SetDisplayValue(Login_Stelle,3,0,0);
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE SetAllDisplayText(SADT1 : VALUE, SADT2 : VALUE)
 SELECT (SADT1*1) OF
  CASE SADT_INIT_SECTION:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_INIT_SECTION);
   ELSE
    SetDisplayText(TEXT_INIT_SECTION,5,0,0);
   END_IF;

  CASE SADT_INIT_BARCODE:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_INIT_BARCODE);
   ELSE
    SetDisplayText(TEXT_INIT_BARCODE,5,0,0);
   END_IF;

  CASE SADT_READY_BIGDATA:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_READY_BIGDATA);
   ELSE
    SetDisplayText(TEXT_READY_BIGDATA,5,0,0);
   END_IF;
 
  CASE SADT_DEBUG:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_DEBUG);
   ELSE
    SetDisplayText(TEXT_DEBUG,5,0,0);
   END_IF;

  CASE SADT_ERROR_SF1:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_ERR);
    WriteText(0,15,TEXT_SF1);
   ELSE
    SetDisplayText(TEXT_ERR,1,0,0);
    SetDisplayText(TEXT_SF1,2,0,0);
    SetDisplayValue(STRINGSTATUS_BigDataString * (-1),3,0,0);  
   END_IF;

  CASE SADT_ERROR_SF2:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_ERR);
    WriteText(0,15,TEXT_SF2);
   ELSE
    SetDisplayText(TEXT_ERR,1,0,0);
    SetDisplayText(TEXT_SF2,2,0,0);
    SetDisplayValue(STRINGSTATUS_BigDataString * (-1),3,0,0);  
   END_IF;

  CASE SADT_ERROR_SF3:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_ERR);
    WriteText(0,15,TEXT_SF3);
   ELSE
    SetDisplayText(TEXT_ERR,1,0,0);
    SetDisplayText(TEXT_SF3,2,0,0);
    SetDisplayValue(STRINGSTATUS_BigDataString * (-1),3,0,0); 
   END_IF;

  CASE SADT_ERROR_DONGLE:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_ERR);
    WriteText(0,15,TEXT_DONGLE);
   ELSE
    SetDisplayText(TEXT_ERR,1,0,0);
    SetDisplayText(TEXT_DONGLE,2,0,0);
    SetDisplayValue(SADT2*1,3,0,0);
   END_IF;

  CASE SADT_ERROR_A19:
   IF (V900DeviceIsPresent) THEN
    WriteText(0,0,TEXT_A19);
   ELSE
    SetDisplayText(TEXT_A19,1,0,0);  
    SELECT (SADT2*1) OF
     CASE /*01*/ BIGDATA_ERROR_NO_RAM:                         //: VALUE := 1;
      SetDisplayText("001",2,0,0);  
     CASE /*02*/ BIGDATA_ERROR_TX_TIMEOUT:                     //: VALUE := 2;
      SetDisplayText("002",2,0,0);  
     CASE /*03*/ BIGDATA_ERROR_RX_UNKNOWN_COMMAND:             //: VALUE := 3;
      SetDisplayText("003",2,0,0);
      SetDisplayValue(Rx_Message_ID,3,0,0);        
     CASE /*04*/ BIGDATA_ERROR_TX_BUFFER_OVERFLOW:             //: VALUE := 4;
      SetDisplayText("004",2,0,0);  
     CASE /*05*/ BIGDATA_ERROR_NO_MEMORY:                      //: VALUE := 5;
      SetDisplayText("005",2,0,0);  
     CASE /*06*/ BIGDATA_ERROR_PARAMETER_SIZE:                 //: VALUE := 6;
      SetDisplayText("006",2,0,0);  
     CASE /*07*/ BIGDATA_ERROR_NOT_ENABLED:                    //: VALUE := 7;
      SetDisplayText("007",2,0,0);  
    END_SELECT;
    Fkt_While();
   END_IF;

  CASE SADT_TX_BUFFER:
   IF (V900DeviceIsPresent) THEN
    Debug_Add_Tx_String_V900();
   ELSE
    SetDisplayText(STRING_Tx,5,0,0);  
   END_IF;
  
  CASE SADT_INIT_LOGIN:  
   Login_Value  := 0;
   Login_Stelle := 0;
//   Login_Aktiv  := TRUE;
//   Wait_Login   := TRUE;
//   ShowUserValue();   
   ActualDisplay := DISPLAY_INIT_LOGIN;
   
  CASE SADT_INIT_SERVICECALL:
   Login_Value  := 0;
   Login_Stelle := 0;
//   ServiceCall_Aktiv  := TRUE;
//   ShowServiceCall();
   ActualDisplay := DISPLAY_INIT_SERVICECALL;
  
 
 END_SELECT;

END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Tx_Manager()//xxxx

//BigData_TxD_RepeatCounter <= BigData_RepeatMaxCount



 SELECT (Status_Connection_Lost) OF
  CASE 0:
   IF (BigData_Connection_Lost) THEN//force send of power on message when connection lost
    IF (NOT bCreateDisplayActiv) THEN
     SetDisplayText(STRING_A23,3,0,0);
    END_IF;
    //SetBeepShort();
    Status_Connection_Lost := 1;
   END_IF;
  CASE 1:
   Actual_Tx_Info                        := 0;
   BigData_TxManager_ActualFillBuffer    := 0;
   BigData_TxManager_ActualSendBuffer    := 0;
   WaitForAck                            := FALSE;
   BigData_SendString(BIGDATA_ID_SEND_POWER_ON);
   Status_Connection_Lost := 2;
  CASE 2:
   IF (NOT BigData_Connection_Lost) THEN
    IF (NOT bCreateDisplayActiv) THEN
     SetAllDisplay_KillDisplay();
     SetBeepShort();
    END_IF;
    Status_Connection_Lost := 0;
   END_IF;  
 END_SELECT;



//SetDisplayValue(BigData_TxD_RepeatCounter,1,0,0);
//SetDisplayValue(BigData_RepeatMaxCount,2,0,0);
//SetDisplayValue(Status_Connection_Lost,3,0,0);

IF (Actual_Tx_Info = 0) THEN//Prfen, ob Sendebuffer gerade frei ist
 IF (BigData_TxManager_ActualFillBuffer <> BigData_TxManager_ActualSendBuffer) THEN//Prfen, ob es etwas zum Senden gibt
  SELECT (BigData_TxManager_ActualSendBuffer) OF
   CASE 01: Send_Infos_TO_PC_test(Array_TxSend_01*1); 
   CASE 02: Send_Infos_TO_PC_test(Array_TxSend_02*1); 
   CASE 03: Send_Infos_TO_PC_test(Array_TxSend_03*1); 
   CASE 04: Send_Infos_TO_PC_test(Array_TxSend_04*1); 
   CASE 05: Send_Infos_TO_PC_test(Array_TxSend_05*1); 
   CASE 06: Send_Infos_TO_PC_test(Array_TxSend_06*1); 
   CASE 07: Send_Infos_TO_PC_test(Array_TxSend_07*1); 
   CASE 08: Send_Infos_TO_PC_test(Array_TxSend_08*1); 
   CASE 09: Send_Infos_TO_PC_test(Array_TxSend_09*1); 
   CASE 10: Send_Infos_TO_PC_test(Array_TxSend_10*1); 
  END_SELECT; 
  
//Senden angeschubst also den Zhler erhhen  
//  IF (NOT BigData_Connection_Lost) THEN
   BigData_TxManager_ActualSendBuffer := BigData_TxManager_ActualSendBuffer + 1;
//  END_IF;
  IF (BigData_TxManager_ActualSendBuffer > 10) THEN
   BigData_TxManager_ActualSendBuffer := 1;
  END_IF;
 END_IF;
END_IF;



 IF ((WaitForAck) AND (BigData_TxD_RepeatTime <> 0)) THEN
  IF (NOT TimerIsRunning(TIMER_TX)) THEN
  
   Send_STRING_Tx();
//   IF (ToggleTxSymbol) THEN
//    ClearDisplaySymbol(SymLevel);
//    ClearDisplaySymbol(SymF1Up);    
//    ToggleTxSymbol := FALSE;
//   ELSE
//    SetDisplaySymbol(SymLevel);
//    SetDisplaySymbol(SymF1Up);
//    ToggleTxSymbol := TRUE;
//   END_IF;
  END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//PROCEDURE SendSewInformationNow(SSIN_Wert : VALUE)
//// SetBeepShort();
// BigData_Tx_Manager();
//END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_SendString(SATB_Wert : VALUE)
IF (NOT BigData_Connection_Lost OR (SATB_Wert = BIGDATA_ID_SEND_POWER_ON)) THEN



IF (BigData_TxManager_ActualSendBuffer = 0) THEN
 BigData_TxManager_ActualSendBuffer := 1;//nur bei power on beim ersten aufruf
END_IF;
IF (BigData_TxManager_ActualFillBuffer = 0) THEN
 BigData_TxManager_ActualFillBuffer := 1;//nur bei power on beim ersten aufruf
END_IF;

//Nachrichten Kennung in Abarbeitungsliste
SELECT (BigData_TxManager_ActualFillBuffer) OF
 CASE 01: Array_TxSend_01 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 02: Array_TxSend_02 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 03: Array_TxSend_03 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 04: Array_TxSend_04 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 05: Array_TxSend_05 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 06: Array_TxSend_06 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 07: Array_TxSend_07 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 08: Array_TxSend_08 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 09: Array_TxSend_09 := SATB_Wert*1;//                                  : VALUE := 0;
 CASE 10: Array_TxSend_10 := SATB_Wert*1;//                                  : VALUE := 0;
END_SELECT;

/*
//Sonderfall um nahtinfo schneller abzuschicken
SendNow := FALSE;
IF (BigData_TxManager_ActualFillBuffer = BigData_TxManager_ActualSendBuffer) THEN
// CreateDisplay();
// SetDisplayValue(BigData_TxManager_ActualFillBuffer,1,0,0);
// SetDisplayValue(BigData_TxManager_ActualSendBuffer,2,0,0);
 SELECT (SATB_Wert) OF
  CASE BIGDATA_ID_SEND_SEW_INFORMATION:
   SendNow := TRUE;
  CASE BIGDATA_ID_SEND_SHORT_SEW_INFORMATION:
   SendNow := TRUE;
 END_SELECT; 
END_IF;
*/

//Fr die nchste Nachricht schon mal den index erhhen
BigData_TxManager_ActualFillBuffer := BigData_TxManager_ActualFillBuffer + 1;

//berschlag prfen
IF (BigData_TxManager_ActualFillBuffer > 10) THEN
 BigData_TxManager_ActualFillBuffer := 1;
END_IF;

//Wenn der fll index und der schreib index gleich sind, dann wurde es nicht schnell genug abgearbeitet
IF (BigData_TxManager_ActualFillBuffer = BigData_TxManager_ActualSendBuffer) THEN
 SetAllDisplayText(SADT_ERROR_A19,BIGDATA_ERROR_TX_BUFFER_OVERFLOW);
 Fkt_While();
END_IF;



END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SpecialFunction_NewBigDataArray()

 STRINGSTATUS_BigDataString := SpecialFunction(SF_CREATE_BIGDATA_TXBUFFER, 
 BIGDATASTRINGSIZE,//length in bytes
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 );
 STRINGLENGTH_BigDataString := 0;
 IF (STRINGSTATUS_BigDataString < 0) THEN
  SetAllDisplay_CreateDisplay();
  SetAllDisplayText(SADT_ERROR_SF1,0);
    Fkt_While();
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE NewBigDataArray()
 SpecialFunction_NewBigDataArray();
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SpecialFunction_SendBigDataArray()
 STRINGSTATUS_BigDataString := SpecialFunction(SF_SEND_BIGDATA_TXBUFFER, 
 0,//StartIndex
 STRINGLENGTH_BigDataString*1,//Len
 PC_DEVICE_NUMBER_ADRESS,//DevNum
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 );
 IF (STRINGSTATUS_BigDataString < 0) THEN
  SetAllDisplay_CreateDisplay();
  SetAllDisplayText(SADT_ERROR_SF2,0);
  
  IF (STRINGSTATUS_BigDataString * (-1) = 5) THEN
   SetAllDisplay_CreateDisplay();
   
//   WHILE (1)
//    SetDisplayValue(GetSystemInfo(SYSTEMINFO_BigData_SoftwareEnable),1,0,0);
//    SetDisplayValue(GetSystemInfo(SYSTEMINFO_BigData_DongleEnable),2,0,0);
//    SetDisplayValue(Dongle_Typ,3,0,0);
//    //SetDisplayText(STRING_BigDataString,5,0,0);
//   END_WHILE;
   
   SetAllDisplayText(SADT_ERROR_A19,BIGDATA_ERROR_NOT_ENABLED);
  END_IF;
    Fkt_While();
 END_IF;
 

 
// SetDisplayValue(STRINGLENGTH_BigDataString,1,0,0);
// SetDisplayValue(STRINGSTATUS_BigDataString,2,0,0);
// Waitms(1000);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SendBigDataArray() 
 IF (StringMessageMode = MM_DONGLE) THEN
  DevSendString(DONGLE_DEVICE_ADRESS, STRING_BigDataString);
  IF (Ablauf_BigData_Cont = 102) THEN
   Waitms(100);
   Ablauf_BigData_Cont := 500;
  END_IF;
 ELSE
  SpecialFunction_SendBigDataArray();
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SpecialFunction_AddStringToBigDataArray()
//     CreateDisplay();
////     SetBeepShort();
//     SetDisplayText(STRING_BigDataString,5,0,0);
////     STRINGLENGTH_BigDataString := 1;
////     SetDisplayValue(STRINGLENGTH_BigDataString,2,0,0);
////     SetDisplayValue(StringLen(STRING_BigDataString),3,0,0);
//     Waitms(3000);
//     SetDisplayValue(STRINGLENGTH_BigDataString,2,0,0);
//     SetDisplayValue(StringLen(STRING_BigDataString),3,0,0);
IF (STRINGLENGTH_BigDataString + StringLen(STRING_BigDataString) + 10 < BIGDATASTRINGSIZE) THEN
 STRINGSTATUS_BigDataString := SpecialFunction(SF_COPY_USERSTRING_TO_BIGDATA_TXBUFFER, 
 BIGDATASTRINGNUMBER,//UserStringNr
 STRINGLENGTH_BigDataString,//StartIndex
 StringLen(STRING_BigDataString),//Len
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 );
//     SetBeepShort();
// SetDisplayValue(STRINGSTATUS_BigDataString,1,0,0);
// SetDisplayValue(STRINGLENGTH_BigDataString,2,0,0);
// SetDisplayValue(StringLen(STRING_BigDataString),3,0,0);
////// SetDisplayText("copy",2,0,0);
//// Waitms(2000);
////     SetDisplayText(STRING_BigDataString,5,0,0);
//     Waitms(3000);
 
 IF (STRINGSTATUS_BigDataString < 0) THEN
  SetAllDisplay_CreateDisplay();
  SetAllDisplayText(SADT_ERROR_SF3,0);
    Fkt_While();
 END_IF;
 STRINGLENGTH_BigDataString := STRINGLENGTH_BigDataString + StringLen(STRING_BigDataString);
 IF (StringMessageMode = MM_BIGDATA) THEN
  StringCopy(STRING_BigDataString,"");
 END_IF;
ELSE
  SetAllDisplay_CreateDisplay();
  SetAllDisplayText(SADT_ERROR_SF3,0);
  Fkt_While();
END_IF;
END_PROCEDURE



//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendValueToSendString(AVTSS : VALUE, AVTSS_Len : VALUE)
// IF (SendFastSeamEnd) THEN
  Valsprintf := AVTSS*1;
  Valsprintf := sprintf (STRING_TEMP1,"%lu,",Valsprintf); 
  StringAppend(STRING_BigDataString,STRING_TEMP1);  
// ELSE
//  ValueToString(STRING_TEMP1,AVTSS*1);
//  StringAppend(STRING_BigDataString,STRING_TEMP1);  
//  StringAppend(STRING_BigDataString,",");
// END_IF;




//     SetBeepShort();
//     SetDisplayText(STRING_BigDataString,5,0,0);
//     Waitms(3000);


SpecialFunction_AddStringToBigDataArray();// AddStringToBigDataArray();
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendStringToSendString(ASTSS : VALUE, ASTSS_Len : VALUE)
 SELECT (ASTSS*1) OF
  CASE SEAM_STRING_TEMP1:
   StringAppend(STRING_BigDataString,STRING_TEMP1);
   //StringAppend(STRING_BigDataString,",");
   //SetDisplayText(STRING_TEMP1,5,0,0);
   //Waitms(2000);
  CASE STRING_SIGNDAT_PARAM:
   StringAppend(STRING_BigDataString,"[EFKA FILEINFO=00100001]");

 END_SELECT;
 SpecialFunction_AddStringToBigDataArray();//AddStringToBigDataArray();
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendSectionStringToSendString(ASSTSS : VALUE, ASSTSS_Len : VALUE)
// SELECT (ASTSS*1) OF
//  CASE SEAM_INFO_S0:
//   StringAppend(STRING_Tx,"S0,");
//  ELSE:
//   AVTSS_Len1 := 1;
//   AVTSS_Len2 := StringLen(STRING_Tx);
//   IF (AVTSS_Len1 + AVTSS_Len2 < SIZE_STRING_TEMP) THEN
//    StringAppend(STRING_Tx,"S");
//   END_IF; 
//   ValueToString(STRING_TEMP1,ASTSS*1);
//   AVTSS_Len1 := StringLen(STRING_TEMP1);
//   AVTSS_Len2 := StringLen(STRING_Tx);
//   IF (AVTSS_Len1 + AVTSS_Len2 < SIZE_STRING_TEMP) THEN   
//    StringAppend(STRING_Tx,STRING_TEMP1);
//    StringAppend(STRING_Tx,",");
//   END_IF; 
// END_SELECT;

 SELECT (ASSTSS*1) OF
  CASE SEAM_INFO_S0:
   StringAppend(STRING_BigDataString,"S0,");
//  CASE STRING_SIGNDAT_PARAM:
//   StringAppend(STRING_BigDataString,"[EFKA FILEINFO=00100001]");
  ELSE:
   StringAppend(STRING_BigDataString,"S");
   ValueToString(STRING_TEMP1,ASSTSS*1);
   StringAppend(STRING_BigDataString,STRING_TEMP1);
   StringAppend(STRING_BigDataString,",");
   

 END_SELECT;
 SpecialFunction_AddStringToBigDataArray();//AddStringToBigDataArray();



END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Send_STRING_Tx()

//Ablauf_SendStringTest := Ablauf_SendStringTest + 1;     

 WatchdogTimerReset();
 IF (BigData_RepeatMaxCount) THEN
  IF (Actual_Tx_Info = BIGDATA_ID_SEND_POWER_ON) THEN
   BigData_TxD_RepeatCounter := 0;
  END_IF;
  IF (BigData_TxD_RepeatCounter <= BigData_RepeatMaxCount) THEN
   BigData_TxD_RepeatCounter := BigData_TxD_RepeatCounter + 1;
  ELSE
//error when no connection   SetAllDisplayText(SADT_ERROR_A19,BIGDATA_ERROR_TX_TIMEOUT); 
   BigData_Connection_Lost := TRUE;
//   CreateDisplay();
//   SetBeepShort();
//SetDisplayValue(BigData_TxD_RepeatCounter,1,0,0);
//SetDisplayValue(BigData_RepeatMaxCount,2,0,0);
//Waitms(2000);   
   
   
   
  END_IF;
 END_IF; 
 ClearTimer(TIMER_TX);
 SetTimer(TIMER_TX, Time_Tx_Repeat);
 //DevSendString(PC_DEVICE_ADRESS, STRING_Tx);
// ;
//SetDisplayValue(Actual_Tx_Info,1,0,0);   
//SetBeepShort();
 SendBigDataArray();
 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SetMessageKeywords(SMK_Typ : VALUE)
 IF (BigData_MessageKeywords) THEN
  SELECT (SMK_Typ) OF
   CASE KEYWORD_COMMAND:
    StringCopy(STRING_BigDataString,"CMD=");
   CASE KEYWORD_REQUEST:
    StringCopy(STRING_BigDataString,"REQ=");
   CASE KEYWORD_RESPONSE:
    StringCopy(STRING_BigDataString,"RES=");
   CASE KEYWORD_DONGLE:
    StringCopy(STRING_BigDataString,"DON=");
   CASE KEYWORD_EXCOMMAND:
    StringCopy(STRING_BigDataString,"EXCMD=");
   CASE KEYWORD_EXREQUEST:
    StringCopy(STRING_BigDataString,"EXREQ=");
   CASE KEYWORD_EXRESPONSE:
    StringCopy(STRING_BigDataString,"EXRES=");

  END_SELECT;
 ELSE
  StringCopy(STRING_BigDataString,"INF=");
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendMessageCounterToSendString(AMCTSS_EX : VALUE)
//     SetBeepShort();
//     SetDisplayValue(Actual_Tx_Info,1,0,0);
//     SetDisplayValue(BigData_MessageModeWithMessageCounter,2,0,0);
//     SetDisplayValue(Actual_Tx_MessageCounter,3,0,0);
//     Waitms(3000);
AMCTSS_EX := 0;

IF (StringMessageMode = MM_DONGLE) THEN
 SELECT (Actual_Tx_Info) OF
 /*101*/CASE DONGLE_ID_SEND_DETECT_REQUEST                        :// VALUE := 101;                   //to Dongle
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*102*/CASE DONGLE_ID_SEND_DETECT_ANSWER_TO_CONTROL_BOX          :// VALUE := 102;        //to control box
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*103*/CASE DONGLE_ID_SEND_DETECT_ENABLE                         :// VALUE := 103;                      //to Dongle
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*104*/CASE DONGLE_ID_SEND_ERROR_TO_CONTROL_BOX                  :// VALUE := 104;                 //to control box
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*105*/CASE DONGLE_ID_SEND_RESTART                               :// VALUE := 105;                              //to Dongle
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*106*/CASE DONGLE_ID_SEND_DELETE_BLID                           :// VALUE := 106;                          //to Dongle
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*107*/CASE DONGLE_ID_SEND_GETVERSIONID_REQUEST                  :// VALUE := 107;                 //to Dongle
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*108*/CASE DONGLE_ID_SEND_GETVERSIONID_ANSWER_TO_CONTROL_BOX    :// VALUE := 108;   //to control box
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 /*109*/CASE DONGLE_ID_SEND_ACK_TO_CONTROL_BOX                    :// VALUE := 109;                   //to control box 
  AppendValueToSendString(Actual_Tx_Info - 100,0);
 END_SELECT;
ELSE
 AppendValueToSendString(Actual_Tx_Info*1,0);
END_IF;

 IF (BigData_MessageModeWithMessageCounter) THEN
  SELECT (Actual_Tx_Info) OF//message counter for answers must be the same from the command/request from pc
   CASE BIGDATA_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP: 
    Actual_Tx_MessageCounter := Rx_Message_Counter;
    //fehler war wohl copy paste AMCTSS_EX := 1;
    
   CASE BIGDATA_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP: 
    Actual_Tx_MessageCounter := Rx_Message_Counter;
    //fehler war wohl copy paste AMCTSS_EX := 1;
   CASE BIGDATA_ID_SEND_GETPARAMETER_ANSWER: 
    Actual_Tx_MessageCounter := Rx_Message_Counter;
    //fehler war wohl copy paste AMCTSS_EX := 1;

   CASE EX_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP: 
    Actual_Tx_MessageCounter := Rx_Message_Counter;
    AMCTSS_EX := 1;
   CASE EX_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP: 
    Actual_Tx_MessageCounter := Rx_Message_Counter;
    AMCTSS_EX := 1;
   CASE EX_ID_SEND_GETPARAMETER_ANSWER:
    Actual_Tx_MessageCounter := Rx_Message_Counter;
    AMCTSS_EX := 1;
   CASE EX_ID_SEND_PIECECOUNTER_VALUE_0:
    Actual_Tx_MessageCounter := Rx_Message_Counter;
    AMCTSS_EX := 1;
    
    
    
       
  END_SELECT;
  AppendValueToSendString(Actual_Tx_MessageCounter*1,3); 
  Actual_Tx_MessageCounter := Actual_Tx_MessageCounter + 1;
  IF (Actual_Tx_MessageCounter > 255) THEN
   Actual_Tx_MessageCounter := 0;
  END_IF;
  IF (AMCTSS_EX) THEN
   AppendValueToSendString(Actual_Rx_UniqueIdentifier*1,3); 
  END_IF;
 END_IF;
 //SetDisplayValue(Actual_Tx_MessageCounter,1,0,0);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendRxMessageCounterToSendString(ARXMCTSS_EX : VALUE)
 AppendValueToSendString(Actual_Tx_Info*1,0);
 IF (BigData_MessageModeWithMessageCounter) THEN
  AppendValueToSendString(Rx_Message_Counter*1,3); 
 END_IF;
 IF (ARXMCTSS_EX) THEN
  AppendValueToSendString(Actual_Rx_UniqueIdentifier*1,3); 
 END_IF;
 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendControlBoxInfoToSendString()
      AppendValueToSendString(VAL_PARA_MACHINE_ID*1,5);//machine ID
      AppendValueToSendString(VAL_USER_ID_1*1,5);
      AppendValueToSendString(VAL_USER_ID_2*1,5);
      AppendValueToSendString(VAL_USER_ID_3*1,5);  
      Section_Value := GetSystemInfo(34);//SYSTEMINFO_LPNR_1
      ValueToString(STRING_TEMP1, Section_Value);
      AppendStringToSendString(SEAM_STRING_TEMP1,6);
      Section_Value := GetSystemInfo(35);//SYSTEMINFO_LPNR_2
      ValueToString(STRING_TEMP1, Section_Value);
      AppendStringToSendString(SEAM_STRING_TEMP1,6);
      StringCopy(STRING_TEMP1, ",");
      AppendStringToSendString(SEAM_STRING_TEMP1,1);
      //AppendValueToSendString(GetSystemInfo(1)*1,12);//LFD
      AppendValueToSendString(GetSystemInfo(2)*1,8);//SN
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendSoftwareVersionToSendString()
 //Progamnummer mit Index
 GetID(PROGNR,STRING_TEMP2); 
 StringCopy(STRING_TEMP1,STRING_TEMP2);
 //Leerzeichen
 StringAppend(STRING_TEMP1," ");      
 //Jahr
 GetID(DATE,STRING_TEMP2);      
 TempVal1 := SignToValue(STRING_TEMP2,9);
 ValueToSign(STRING_TEMP2,TempVal1);
 StringAppend(STRING_TEMP1,STRING_TEMP2);
 //StringAppend(STRING_TEMP1,"_");      
 GetID(DATE,STRING_TEMP2);      
 TempVal1 := SignToValue(STRING_TEMP2,10);
 ValueToSign(STRING_TEMP2,TempVal1);
 StringAppend(STRING_TEMP1,STRING_TEMP2);
 //StringAppend(STRING_TEMP1,"_");          
 //Monat
 GetID(DATE,STRING_TEMP2);      
 IF (StringNCompare(STRING_TEMP2,"Jan",3) = 0) THEN
  StringAppend(STRING_TEMP1,"01");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Feb",3) = 0) THEN
  StringAppend(STRING_TEMP1,"02");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Mar",3) = 0) THEN
  StringAppend(STRING_TEMP1,"03");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Apr",3) = 0) THEN
  StringAppend(STRING_TEMP1,"04");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"May",3) = 0) THEN
  StringAppend(STRING_TEMP1,"05");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Jun",3) = 0) THEN
  StringAppend(STRING_TEMP1,"06");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Jul",3) = 0) THEN
  StringAppend(STRING_TEMP1,"07");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Aug",3) = 0) THEN
  StringAppend(STRING_TEMP1,"08");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Sep",3) = 0) THEN
  StringAppend(STRING_TEMP1,"09");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Oct",3) = 0) THEN
  StringAppend(STRING_TEMP1,"10");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Nov",3) = 0) THEN
  StringAppend(STRING_TEMP1,"11");
 END_IF;   
 IF (StringNCompare(STRING_TEMP2,"Dec",3) = 0) THEN
  StringAppend(STRING_TEMP1,"12");
 END_IF;   
 //StringAppend(STRING_TEMP1,"_"); 
 //Tag
 GetID(DATE,STRING_TEMP2);      
 TempVal1 := SignToValue(STRING_TEMP2,4);
 ValueToSign(STRING_TEMP2,TempVal1);
 StringAppend(STRING_TEMP1,STRING_TEMP2);
 GetID(DATE,STRING_TEMP2);      
 TempVal1 := SignToValue(STRING_TEMP2,5);
 ValueToSign(STRING_TEMP2,TempVal1);
 StringAppend(STRING_TEMP1,STRING_TEMP2);
 //StringAppend(STRING_TEMP1,"_"); 
 //Stunde
 GetID(TIME,STRING_TEMP2);
 StringNAppend(STRING_TEMP1,STRING_TEMP2,2);  
 StringAppend(STRING_TEMP1,","); 
   
 AppendStringToSendString(SEAM_STRING_TEMP1,5);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_DataDump_SendParameterList(BDDSPL_j : VALUE, BDDSPL_k : VALUE, BDDSPL_len : VALUE)

 BDDSPL_k := 0;
 SELECT (DataDump_MerkerParalist) OF
//------------------------------------------- 
  CASE 0://Preload Parameter
   DataDump_paranum := SetSystemInfo(SYSTEMINFO_BigData_FosPreLoadPara,BDDSPL_k*1);
   WHILE (DataDump_paranum <> 0xFFFF)
    SetTaskTime(TASKTIME_MAX); 
    IF (ParaExist(DataDump_paranum)) THEN
     AppendValueToSendString(DataDump_paranum*1,5);
     AppendValueToSendString(GetParameter(DataDump_paranum),5);
     DataDump_AmoutOfData := DataDump_AmoutOfData - 1; 
    END_IF;
    BDDSPL_k := BDDSPL_k + 1;
    DataDump_paranum := SetSystemInfo(SYSTEMINFO_BigData_FosPreLoadPara,BDDSPL_k*1);
   END_WHILE;
   DataDump_MerkerParalist := 1;

//------------------------------------------- 
  CASE 1://Normal Parameter
   SetTaskTime(TASKTIME_MAX); 
   TempVal2 := 0;//Value to finish actual data package   
   //BDDSPL_len := DataDump_len_pardef_cmn;//GetSystemInfo(SYSTEMINFO_len_pardef_cmn);
   DataDump_MerkerParalist := 1;
//     SetBeepShort();
//     SetDisplayValue(DataDump_IndexOfData,1,0,0);
//     SetDisplayValue(BDDSPL_len*1,2,0,0);
//     Waitms(1000);
   WHILE ((DataDump_IndexOfData < DataDump_len_pardef_cmn/*BDDSPL_len*/) AND (TempVal2 = 0))//is NOT DataDump_paranum, is index in paralist
      SetTaskTime(TASKTIME_MAX);
    TempVal1 := SetSystemInfo(SYSTEMINFO_pardef_LoadMode,DataDump_IndexOfData);
//     SetBeepShort();
//     SetDisplayValue(DataDump_IndexOfData,1,0,0);
//     SetDisplayValue(TempVal1*1,2,0,0);
//     Waitms(1000);
    IF (TempVal1) THEN
     DataDump_paranum := SetSystemInfo(SYSTEMINFO_GetParaNumFrompardefIndex,DataDump_IndexOfData);//Get ParameterNumber from Index
//     SetBeepShort();
//     SetDisplayValue(DataDump_paranum,1,0,0);
//     Waitms(1000);
     IF (ParaExist(DataDump_paranum)) THEN
      AppendValueToSendString(DataDump_paranum*1,5);
      AppendValueToSendString(GetParameter(DataDump_paranum),5);
/*
      testcounter1 := testcounter1 + 1;
      //IF (testcounter1 < 100) THEN
      //IF (testcounter1 < 50) THEN
      IF (testcounter1 < 88) THEN
       CreateDisplay();
       SetDisplayValue(DataDump_paranum,1,0,0);
       AppendValueToSendString(GetParameter(DataDump_paranum),5);
      ELSE
       AppendValueToSendString(1,5);
      END_IF;
      */
//     SetDisplayValue(GetParameter(DataDump_paranum),2,0,0);
      DataDump_AmoutOfData := DataDump_AmoutOfData - 1; 
      IF (DataDump_AmoutOfData = 0) THEN
       TempVal2 := 1;
       DataDump_MerkerParalist := 2;//all data are in data package, finish data collection
      END_IF;
//     SetDisplayValue(DataDump_AmoutOfData,3,0,0);
      IF (STRINGLENGTH_BigDataString >= BIGDATASTRINGSIZE / 2/*- 30*/) THEN//Transmitdata is full, finish actual data package
       TempVal2 := 2;
      END_IF;
     END_IF;
//     Waitms(1000);
    END_IF;
//     SetBeepShort();
//     SetDisplayValue(DataDump_IndexOfData,1,0,0);
//     SetDisplayValue(STRINGLENGTH_BigDataString*1,2,0,0);
//     SetDisplayValue(TempVal2*1,3,0,0);
//     Waitms(1000);
    DataDump_IndexOfData := DataDump_IndexOfData + 1;
   END_WHILE;
//     SetBeepShort();
//     SetDisplayValue(DataDump_IndexOfData,1,0,0);
//     SetDisplayValue(STRINGLENGTH_BigDataString*1,2,0,0);
//     SetDisplayValue(TempVal2*1,3,0,0);
    // Waitms(1000);
   //DataDump_MerkerParalist := 1;
   IF (DataDump_IndexOfData >= DataDump_len_pardef_cmn/*GetSystemInfo(SYSTEMINFO_len_pardef_cmn)*/) THEN
    DataDump_MerkerParalist := 2;//all data are in data package, finish data collection
   END_IF;
   SetTaskTime(Val_TASKTIME*1);

//------------------------------------------- 
  CASE 2://Postload Parameter
//   DataDump_paranum := SetSystemInfo(SYSTEMINFO_BigData_FosPostLoadPara,BDDSPL_k*1);
//   WHILE (DataDump_paranum <> 0xFFFF)
//    IF (ParaExist(DataDump_paranum)) THEN
//     AppendValueToSendString(DataDump_paranum*1,5);
//     AppendValueToSendString(GetParameter(DataDump_paranum),5);
//     DataDump_AmoutOfData := DataDump_AmoutOfData - 1; 
//    END_IF;
//    BDDSPL_k := BDDSPL_k + 1;
//    DataDump_paranum := SetSystemInfo(SYSTEMINFO_BigData_FosPostLoadPara,BDDSPL_k*1);
//   END_WHILE;
   DataDump_MerkerParalist := 3;
   
   
//     SetBeepShort();
//     SetDisplayValue(DataDump_AmoutOfData,1,0,0);
//     Waitms(1000);
   DataDump_AmoutOfData := 0;


 END_SELECT;  


END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE AppendEmptyLine()
 StringCopy(STRING_TEMP1, "");
 AppendStringToSendString(SEAM_STRING_TEMP1,0);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_DataDump_SendControlBoxInfo()

 SELECT (DataDump_AppendControlBoxInfo) OF
  CASE 1:
   AppendEmptyLine();
   DataDump_AppendControlBoxInfo := DataDump_AppendControlBoxInfo + 1;                     
  CASE 2:
   StringCopy(STRING_TEMP1, "***** Do not change the sequence of parameter ******");
   AppendStringToSendString(SEAM_STRING_TEMP1,0);
   DataDump_AppendControlBoxInfo := DataDump_AppendControlBoxInfo + 1;                     
  CASE 3:
   AppendEmptyLine();
   DataDump_AppendControlBoxInfo := DataDump_AppendControlBoxInfo + 1;                     
  CASE 4:
   StringCopy(STRING_TEMP1, "* PRGNR: ");
   AppendStringToSendString(SEAM_STRING_TEMP1,0);
   AppendSoftwareVersionToSendString();
   DataDump_AppendControlBoxInfo := DataDump_AppendControlBoxInfo + 1;                     
  CASE 5:
   StringCopy(STRING_TEMP1, "* LS-SN: ");
   AppendStringToSendString(SEAM_STRING_TEMP1,0);
   AppendValueToSendString(GetSystemInfo(2)*1,8);//SN                      
   DataDump_AppendControlBoxInfo := DataDump_AppendControlBoxInfo + 1;                     
  CASE 6:
   StringCopy(STRING_TEMP1, "* LS-LFD: ");
   AppendStringToSendString(SEAM_STRING_TEMP1,0);


      Section_Value := GetSystemInfo(34);//SYSTEMINFO_LPNR_1
      ValueToString(STRING_TEMP1, Section_Value);
      AppendStringToSendString(SEAM_STRING_TEMP1,6);
      Section_Value := GetSystemInfo(35);//SYSTEMINFO_LPNR_2
      ValueToString(STRING_TEMP1, Section_Value);
      AppendStringToSendString(SEAM_STRING_TEMP1,6);
      StringCopy(STRING_TEMP1, ",");



   //AppendValueToSendString(GetSystemInfo(1)*1,12);//LFD                             
   DataDump_AppendControlBoxInfo := DataDump_AppendControlBoxInfo + 1;                     
  
  ELSE://finish
   DataDump_AppendControlBoxInfo := 0;
 END_SELECT;


END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//FUNCTION BigData_DataDump_GetAmountParameterList() : VALUE
// BigData_DataDump_GetAmountParameterList := 0;
//END_FUNCTION

//WSITSB_Val = 1 Total
//WSITSB_Val = 0 Sections
PROCEDURE WriteInformationToSendBuffer(WSITSB_Val : VALUE, WSITSB_Mode : VALUE)
//sum of all section values 



 SequenzCounter := 2;
 WHILE (SequenzCounter < Dongle_Val3)
SetTaskTime(TASKTIME_MAX);
//S1,S2,S3,...
  IF (WSITSB_Val = 0) THEN
   AppendSectionStringToSendString(SEAM_INFO_S0 + SequenzCounter - 1,0);
  END_IF;
 
  BigData_Collect_Get(Dongle_Val2*1, SequenzCounter*1, AC_RUN_TIME);
  IF (WSITSB_Val) THEN
   Dongle_Val1 := Dongle_Val1 + AC_GetVal;
  ELSE
   Dongle_Val1 := AC_GetVal;
  END_IF;
  BigData_Collect_Get(Dongle_Val2*1, SequenzCounter*1, AC_STOP_TIME);
  IF (WSITSB_Val) THEN
   Dongle_Val4 := Dongle_Val4 + AC_GetVal;
  ELSE
   Dongle_Val4 := AC_GetVal;
  END_IF;
  BigData_Collect_Get(Dongle_Val2*1, SequenzCounter*1, AC_STITCHES);
  IF (WSITSB_Val) THEN
   Dongle_Val5 := Dongle_Val5 + AC_GetVal;
  ELSE
   Dongle_Val5 := AC_GetVal;
  END_IF;
  IF (Dongle_Val5 = 0) THEN
   Dongle_Val5 := 1;//always minimum 1 stitch
  END_IF;
  IF (Dongle_Val1 + Dongle_Val4 = 0) THEN
   Dongle_Val1 := 1;//always minimum 1 ms
  END_IF;

  IF (WSITSB_Val = 0) THEN//WSITSB_Val = 0 ------------------SECTIONS
   Dongle_Val6 := Dongle_Val5 * 60000;//AC_STITCHES * 60000
   Dongle_Val7  := (Dongle_Val1 + Dongle_Val4);
   Dongle_Val6 := Dongle_Val6 / Dongle_Val7;//


   SELECT (WSITSB_Mode) OF
    CASE SECTION_INFO_ZERO://zero
     Dongle_Val7 := 0;//all values are zero only the section count is used here
     Valsprintf := sprintf (STRING_TEMP1,"%lu,%lu,%lu,%lu,%lu,",Dongle_Val7,Dongle_Val7,Dongle_Val7,Dongle_Val7,Dongle_Val7); 
     StringAppend(STRING_BigDataString,STRING_TEMP1);  //max 200bytes
     Valsprintf := sprintf (STRING_TEMP1,"%lu,%lu,%lu,%lu,",Dongle_Val7,Dongle_Val7,Dongle_Val7,Dongle_Val7); 
     StringAppend(STRING_BigDataString,STRING_TEMP1);  //max 200bytes
     SpecialFunction_AddStringToBigDataArray();   
    CASE SECTION_INFO_REDUCED://reduced stitches,run time,out motorrun, out motor stop 
     Valsprintf := sprintf (STRING_TEMP1,"%lu,%lu,%lu,",/*Dongle_Val7,*/Dongle_Val5,/*Dongle_Val6,*/Dongle_Val1,Dongle_Val4); 
     StringAppend(STRING_BigDataString,STRING_TEMP1);  //max 200bytes
     Valsprintf := sprintf (STRING_TEMP1,"%lu,%lu,",/*Section_Inputs_Motorrun,*/Section_Outputs_Motorrun,/*Section_Inputs_MotorStop,*/Section_Outputs_MotorStop); 
     StringAppend(STRING_BigDataString,STRING_TEMP1);  //max 200bytes
     SpecialFunction_AddStringToBigDataArray();   
    ELSE://CASE 1://normal
     Valsprintf := sprintf (STRING_TEMP1,"%lu,%lu,%lu,%lu,%lu,",Dongle_Val7,Dongle_Val5,Dongle_Val6,Dongle_Val1,Dongle_Val4); 
     StringAppend(STRING_BigDataString,STRING_TEMP1);  //max 200bytes
     Valsprintf := sprintf (STRING_TEMP1,"%lu,%lu,%lu,%lu,",Section_Inputs_Motorrun,Section_Outputs_Motorrun,Section_Inputs_MotorStop,Section_Outputs_MotorStop); 
     StringAppend(STRING_BigDataString,STRING_TEMP1);  //max 200bytes
     SpecialFunction_AddStringToBigDataArray();   
   END_SELECT;

  END_IF;


  SequenzCounter := SequenzCounter + 1;
 END_WHILE;

 IF (WSITSB_Val) THEN//WSITSB_Val = 1 ---------------------TOTAL
 
  Dongle_Val6 := Dongle_Val5 * 60000;//AC_STITCHES * 60000
  Dongle_Val7  := (Dongle_Val1 + Dongle_Val4);
  Dongle_Val6 := Dongle_Val6 / Dongle_Val7;//
  
  ServiceCounter_ExecuteTime  := Dongle_Val1 / 1000;//run time in sec to service counter
  ServiceCounter_ExecuteCount := Dongle_Val5;//stitchcounter to service counter

  //sew time, stitches, average speed, run time, stop time, time between seams
  Valsprintf := sprintf (STRING_TEMP1,"%lu,%lu,%lu,%lu,%lu,%lu,",Dongle_Val7,Dongle_Val5,Dongle_Val6,Dongle_Val1,Dongle_Val4,AC_BETWEENSEAMS_LAST_SEAM); 
  StringAppend(STRING_BigDataString,STRING_TEMP1);  
  SpecialFunction_AddStringToBigDataArray();
 END_IF;


 IF (AC_Stack = 2) THEN
  Collect_Send_Stack_1 := FALSE;
 ELSE
  Collect_Send_Stack_2 := FALSE;
 END_IF;


END_PROCEDURE

PROCEDURE AppendSectionInformation(ASI_Mode : VALUE)
//help values
 Dongle_Val1 := 0;//Total RunTime
 Dongle_Val2 := 0;//previous stack index
 Dongle_Val3 := 0;//precious section count
 Dongle_Val4 := 0;//Total StopTime
 Dongle_Val5 := 0;//Total Stitches
 Dongle_Val6 := 0;//Speed
 Dongle_Val7 := 0;//Time

//Get previous stack index
//get the section count of the previous seam
 IF (AC_Stack = 2) THEN//ex first time after power on
  Dongle_Val2 := 1;//previous index was = 1
  Dongle_Val3 := AC_ONE_Section;
 ELSE//ex second seam this means AC_Stack = 1
  Dongle_Val2 := 2;//previous index was = 2
  Dongle_Val3 := AC_TWO_Section;
 END_IF; 
 WriteInformationToSendBuffer(1,ASI_Mode*1);
 WriteInformationToSendBuffer(0,ASI_Mode*1);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BuildAnswer_Init_GetParameterDump()
 AppendMessageCounterToSendString(0);
 DataDump_IndexOfData          := 0;
 DataDump_AppendControlBoxInfo := 0;
 DataDump_IndexParameterText   := 0;
 //DataDump_AmoutOfData          := 0;
 DataDump_MerkerParalist       := 0;
 DataDump_OrderOfData          := 0;    
 DataDump_TempVal1             := 0; 
//    SetBeepShort(); 
//    SetDisplayValue(BigDataDataDump_Typ,1,0,0);
//    Waitms(1000);
 SELECT (BigDataDataDump_Typ) OF
  CASE DDT_PARAMETER:
   DataDump_AmoutOfData          := GetSystemInfo(SYSTEMINFO_BigData_GetAmountParameterList);
   DataDump_AppendControlBoxInfo := 1;
//    SetBeepShort(); 
//    SetDisplayValue(DataDump_AmoutOfData,2,0,0);
//    Waitms(1000);
   AppendValueToSendString(DDT_PARAMETER,0);
   AppendValueToSendString(DataDump_AmoutOfData*1,0);
  ELSE:
   AppendValueToSendString(DDT_NO,0);
 END_SELECT;
 WaitForAck := FALSE;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BuildAnswer_Cont_GetParameterDump()
 AppendMessageCounterToSendString(0);
 SELECT (BigDataDataDump_Typ) OF
  CASE DDT_PARAMETER:
   DataDump_TempVal1 := 0;
   IF (DataDump_OrderOfData) THEN
    IF (DataDump_AmoutOfData) THEN
     DataDump_TempVal1 := 1;
     AppendValueToSendString(DPT_PARAMETERLIST,0);
    ELSE
     IF (DataDump_AppendControlBoxInfo) THEN
      DataDump_TempVal1 := 2;
      AppendValueToSendString(DPT_TEXTLIST,0);
     ELSE
      DataDump_TempVal1 := 3;
      AppendValueToSendString(DDT_NO,0);
     END_IF;
    END_IF;
   END_IF;
   DataDump_OrderOfData := 1;       
   SELECT (DataDump_TempVal1) OF
    CASE 0:
     AppendValueToSendString(DPT_TEXTLIST,0);
     AppendStringToSendString(STRING_SIGNDAT_PARAM,0);
    CASE 1://ParameterNr+Val
     BigData_DataDump_SendParameterList(0,0,0);
    CASE 2://ControlboxInfo        
     BigData_DataDump_SendControlBoxInfo();
   END_SELECT;       
 END_SELECT; 
 WaitForAck := FALSE;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Send_Infos_TO_PC_test(Info : VALUE)

 BigData_SendData := Info*1;
 CounterInfo := CounterInfo + 1;
 
 IF(Info)THEN
   NewBigDataArray();//-???
   Actual_Tx_Info := Info*1;
   IF (BigData_Ack_Mode = BIGDATA_ACK_MODE_WITH_ACK) THEN
    WaitForAck := TRUE;
   END_IF;
   BigData_TxD_RepeatCounter := 0;


   IF (StringMessageMode = MM_DONGLE) THEN
    SELECT(Info)OF
//-------------------------------------------Dongle    
     CASE DONGLE_ID_SEND_DETECT_REQUEST:
      SetMessageKeywords(KEYWORD_DONGLE);     
      AppendMessageCounterToSendString(0);
      Dongle_Val1 := GetSystemInfo(SYSTEMINFO_Dongle_Get);
      AppendValueToSendString(Dongle_Val1*1,5);
      Dongle_Val2 := GetSystemInfo(SYSTEMINFO_Dongle_Get);
      AppendValueToSendString(Dongle_Val2*1,5);
      Dongle_Val3 := GetSystemInfo(SYSTEMINFO_Dongle_Get);
      AppendValueToSendString(Dongle_Val3*1,5);
      Dongle_Val4 := GetSystemInfo(SYSTEMINFO_Dongle_Get);
      AppendValueToSendString(Dongle_Val4*1,5);
 
     
     CASE DONGLE_ID_SEND_DETECT_ENABLE:
      SetMessageKeywords(KEYWORD_DONGLE);     
      AppendMessageCounterToSendString(0);
      Dongle_Val1 := GetSystemInfo(SYSTEMINFO_Dongle_Val1);
      AppendValueToSendString(Dongle_Val1*1,5);
      Dongle_Val2 := GetSystemInfo(SYSTEMINFO_Dongle_Val2);
      AppendValueToSendString(Dongle_Val2*1,5);
      Dongle_Val3 := GetSystemInfo(SYSTEMINFO_Dongle_Val3);
      AppendValueToSendString(Dongle_Val3*1,5);
      Dongle_Val4 := GetSystemInfo(SYSTEMINFO_Dongle_Val4);
      AppendValueToSendString(Dongle_Val4*1,5);

    END_SELECT;
   ELSE
    SELECT(Info)OF
     
     
      
     
  //-------------------------------------------DataDump    
     CASE EX_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP:
      SetMessageKeywords(KEYWORD_EXRESPONSE);   
      BuildAnswer_Init_GetParameterDump();       
     CASE BIGDATA_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP:
      SetMessageKeywords(KEYWORD_RESPONSE);   
      BuildAnswer_Init_GetParameterDump();  
  
    CASE EX_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP:
      SetMessageKeywords(KEYWORD_EXRESPONSE);     
      BuildAnswer_Cont_GetParameterDump();        
    CASE BIGDATA_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP:
      SetMessageKeywords(KEYWORD_RESPONSE);     
      BuildAnswer_Cont_GetParameterDump();  
      
  
  
  //-------------------------------------------BigData    
     CASE BIGDATA_ID_SEND_WATCHDOGMESSAGE:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
     
     CASE BIGDATA_ID_SEND_POWER_ON:  
       SetMessageKeywords(KEYWORD_COMMAND);
       AppendMessageCounterToSendString(0);
       AppendControlBoxInfoToSendString();
       AppendSoftwareVersionToSendString();
       
       //IF (BigData_PowerOn_Message = 0) THEN
       // WaitForAck := FALSE;
        StringCopy(STRING_BigDataString,"");
       //END_IF;
       PowerOnRunBlockage := 1;
       IF (BigData_Connection_Lost) THEN
        PowerOnRunBlockage := 0;
       END_IF;
  
     CASE BIGDATA_ID_SEND_OPERATOR_ID_LOGIN:    
      SetMessageKeywords(KEYWORD_REQUEST);
      AppendMessageCounterToSendString(0);
      AppendControlBoxInfoToSendString();
      AppendSoftwareVersionToSendString();
  
     CASE BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT:    
      SetMessageKeywords(KEYWORD_REQUEST);
      AppendMessageCounterToSendString(0);
      AppendControlBoxInfoToSendString();
      AppendSoftwareVersionToSendString();
      VAL_USER_ID_1 := 0;
      VAL_USER_ID_2 := 0;
      VAL_USER_ID_3 := 0;
      flag_BigData_SetEnableFpPedal := ON;
       
     CASE EX_ID_SEND_PIECECOUNTER_VALUE_0:
      SetMessageKeywords(KEYWORD_EXRESPONSE);
      AppendRxMessageCounterToSendString(WITH_EX);
      AppendValueToSendString(PieceCounter_COUNT_Act + 1,5);
      AppendValueToSendString(PieceCounter_COUNT_MAX*1,5);
      WaitForAck := FALSE;//PieceCounter_COUNT_Act < PieceCounter_COUNT_MAX - 1
     
     CASE EX_ID_SEND_GETPARAMETER_ANSWER:  
      SetMessageKeywords(KEYWORD_EXRESPONSE);
      AppendRxMessageCounterToSendString(WITH_EX);
      AppendValueToSendString(GetSetParameterNumber*1,5);
      AppendValueToSendString(GetSetParameterValue*1,5);
      WaitForAck := FALSE;
     CASE BIGDATA_ID_SEND_GETPARAMETER_ANSWER:
      SetMessageKeywords(KEYWORD_RESPONSE);
      AppendRxMessageCounterToSendString(NO_EX);
      AppendValueToSendString(GetSetParameterNumber*1,5);
      AppendValueToSendString(GetSetParameterValue*1,5);
      WaitForAck := FALSE;
        
  //------------------------------------------------------------------------------- long sew info   
     CASE BIGDATA_ID_SEND_SEW_INFORMATION:
      SetTaskTime(TASKTIME_MAX);
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
      AppendSectionStringToSendString(SEAM_INFO_S0,0);
      AppendSectionInformation(SECTION_INFO_NORMAL);
      SetTaskTime(Val_TASKTIME*1);
    
  //------------------------------------------------------------------------------- short sew info   
     CASE BIGDATA_ID_SEND_SHORT_SEW_INFORMATION:
      SetTaskTime(TASKTIME_MAX);
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
      AppendSectionStringToSendString(SEAM_INFO_S0,0);
      AppendSectionInformation(SECTION_INFO_NORMAL);
      SetTaskTime(Val_TASKTIME*1);
      
     CASE EX_ID_SEND_ACK_TO_PC:
      SetMessageKeywords(KEYWORD_EXRESPONSE);     
      AppendRxMessageCounterToSendString(WITH_EX);
      WaitForAck := FALSE;
     CASE BIGDATA_ID_SEND_ACK_TO_PC:
      SetMessageKeywords(KEYWORD_RESPONSE);     
      AppendRxMessageCounterToSendString(NO_EX);
      WaitForAck := FALSE;
     
     CASE BIGDATA_ID_SEND_SERVICE_CALL:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
      AppendValueToSendString(VAL_SERVICE_NUMBER*1,5);
     
     CASE BIGDATA_ID_SEND_PIECECOUNTER_READY_0:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
       
     CASE BIGDATA_ID_SEND_SERVICECOUNTER_READY_0:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
       
     CASE BIGDATA_ID_SEND_SERVICECOUNTER_READY_1:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
       
     CASE BIGDATA_ID_SEND_SERVICECOUNTER_READY_2:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
       
     CASE BIGDATA_ID_SEND_SERVICECOUNTER_READY_3:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
       
     CASE BIGDATA_ID_SEND_SERVICECOUNTER_READY_4:
      SetMessageKeywords(KEYWORD_COMMAND);
      AppendMessageCounterToSendString(0);
       
  
       
    END_SELECT;
   END_IF; 
    
    
   IF (Time_Tx_Repeat = 0) THEN
    Time_Tx_Repeat := BigData_TxD_RepeatTime;
   END_IF; 
   //ToggleTxSymbol := FALSE;
   Send_STRING_Tx();
   Info := 0;
   IF (NOT WaitForAck) THEN
    Actual_Tx_Info := 0;
   END_IF;
//  END_IF;
 END_IF;
END_PROCEDURE



//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Ax_Ack()
    WaitForAck := FALSE;
    Actual_Tx_Info := 0;
    Power_On_Message_Aktiv := FALSE;
    //;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE ServiceCounter_Init(SCI_ID : VALUE, SCI_MODE : VALUE, SCI_SSTART : VALUE)
 SELECT (SCI_ID*1) OF
  CASE 1: 
   ServiceCounter_Startwert_1 := SCI_SSTART*1;
   ServiceCounter_Mode_1      := SCI_MODE*1;
   ServiceCounter_Act_1       := SCI_SSTART*1;
   SetParameter(PARA_SERVICECOUNTER_MODE_1,      ServiceCounter_Mode_1);
   SetParameter(PARA_SERVICECOUNTER_STARTWERT_1, ServiceCounter_Startwert_1);
   SetParameter(PARA_SERVICECOUNTER_ACT_1,       ServiceCounter_Act_1);
   SetParameter(PARA_SERVICECOUNTER_SEC_1,       0);
  CASE 2:    
   ServiceCounter_Startwert_2 := SCI_SSTART*1;
   ServiceCounter_Mode_2      := SCI_MODE*1;
   ServiceCounter_Act_2       := SCI_SSTART*1;
   SetParameter(PARA_SERVICECOUNTER_MODE_2,      ServiceCounter_Mode_2);
   SetParameter(PARA_SERVICECOUNTER_STARTWERT_2, ServiceCounter_Startwert_2);
   SetParameter(PARA_SERVICECOUNTER_ACT_2,       ServiceCounter_Act_2);
   SetParameter(PARA_SERVICECOUNTER_SEC_2,       0);
  CASE 3:    
   ServiceCounter_Startwert_3 := SCI_SSTART*1;
   ServiceCounter_Mode_3      := SCI_MODE*1;
   ServiceCounter_Act_3       := SCI_SSTART*1;
   SetParameter(PARA_SERVICECOUNTER_MODE_3,      ServiceCounter_Mode_3);
   SetParameter(PARA_SERVICECOUNTER_STARTWERT_3, ServiceCounter_Startwert_3);
   SetParameter(PARA_SERVICECOUNTER_ACT_3,       ServiceCounter_Act_3);
   SetParameter(PARA_SERVICECOUNTER_SEC_3,       0);
  CASE 4:    
   ServiceCounter_Startwert_4 := SCI_SSTART*1;
   ServiceCounter_Mode_4      := SCI_MODE*1;
   ServiceCounter_Act_4       := SCI_SSTART*1;
   SetParameter(PARA_SERVICECOUNTER_MODE_4,      ServiceCounter_Mode_4);
   SetParameter(PARA_SERVICECOUNTER_STARTWERT_4, ServiceCounter_Startwert_4);
   SetParameter(PARA_SERVICECOUNTER_ACT_4,       ServiceCounter_Act_4);
   SetParameter(PARA_SERVICECOUNTER_SEC_4,       0);
  CASE 5:         
   ServiceCounter_Startwert_5 := SCI_SSTART*1;
   ServiceCounter_Mode_5      := SCI_MODE*1;
   ServiceCounter_Act_5       := SCI_SSTART*1;
   SetParameter(PARA_SERVICECOUNTER_MODE_5,      ServiceCounter_Mode_5);
   SetParameter(PARA_SERVICECOUNTER_STARTWERT_5, ServiceCounter_Startwert_5);
   SetParameter(PARA_SERVICECOUNTER_ACT_5,       ServiceCounter_Act_5);
   SetParameter(PARA_SERVICECOUNTER_SEC_5,       0);
 END_SELECT; 
END_PROCEDURE





//-------------------------------------------------------------------------------------------------------
PROCEDURE Cont_SetParameterDump(CSPD_Counter : VALUE)  
 //SetBeepShort();
 
     BigDataDataDump_Typ  := GetValueRxString(CSPD_Counter*1);
     CSPD_Counter   := CSPD_Counter + 1;    
     CSPD_Counter := GetSystemInfo(SYSTEMINFO_strlen_RxBuffer);
     TempVal1 := 1;//Index
     TempVal2 := 30;//Len
     TempVal3 := 0;//Start Index of Value
     TempVal4 := 0;//Toggle Info ParmeterNumber / ParameterValue
     TempVal5 := 0;//ParmeterNumber
     
     BigDataDataDump_Typ := DDT_PARAMETER;
     
     StringCopy(STRING_TEMP1,"");
     
 //SetDisplayValue(HIM_Counter*1,1,0,0);
 //SetDisplayValue(BigDataDataDump_Typ*1,2,0,0);
 //SetDisplayValue(TempVal2*1,3,0,0);
 //Waitms(1000);    
     
     
     
     SELECT (BigDataDataDump_Typ) OF
      CASE DDT_PARAMETER:
       WHILE (CSPD_Counter)
       SetTaskTime(TASKTIME_MAX);
        
        TempVal2 := SetSystemInfo(SYSTEMINFO_RxBuffer,TempVal1);//RS_CopyRxToUserString(STRING_TEMP1,TempVal1,1);//copy substring
        //TempVal2 := SignToValue(STRING_TEMP1,0);//check byte
 
 //CreateDisplay();
 //SetDisplayValue(TempVal1*1,1,0,0);//acutal Index
 //SetDisplayValue(TempVal2*1,2,0,0);//actual Byte as Value
 //SetDisplayValue(HIM_Counter*1,3,0,0);//len
 //WHILE (VarioButtons = 0)
 //END_WHILE;
 //Waitms(1000);
 //WHILE (VarioButtons)
 //END_WHILE;
 
 
        //if StartIndex is set, collect data
        IF (TempVal3) THEN
         IF ((TempVal2 >= 48) AND (TempVal2 <= 57)) THEN//Is sign a value?
          ValueToSign(STRING_TEMP2,TempVal2);//convert value back to ascii string
          StringAppend(STRING_TEMP1,STRING_TEMP2);//append value
         END_IF;
        END_IF;
 
 
        SELECT (TempVal2) OF
         CASE 44://','
          TempVal4 := TempVal4 + 1;
 //              CreateDisplay();
 //              SetDisplayText(STRING_TEMP1,1,0,0);
 //              SetDisplayValue(TempVal4,2,0,0);
 //              SetDisplayValue(TempVal5,3,0,0);
 //              WHILE (VarioButtons = 0)
 //              END_WHILE;
 //              Waitms(1000);
 //              WHILE (VarioButtons)
 //              END_WHILE;
 
         
          SELECT (TempVal4) OF
           CASE 1://MID
            dummy := dummy;
           CASE 2://MessageCounter 
            dummy := dummy;
           CASE 3://BigDataDataDump_Typ 
            dummy := dummy;
           CASE 4://ParaNumber
            TempVal5 := StringToValue(STRING_TEMP1);
           CASE 5://ParaValue
            TempVal4 := StringToValue(STRING_TEMP1);
  
  
  
 //              CreateDisplay();
 //              SetDisplayValue(GetParameterMinval(TempVal5),1,0,0);
 //              SetDisplayValue(GetParameterMaxval(TempVal5),2,0,0);
 //              SetDisplayValue(TempVal4,3,0,0);
 //           IF (ParaExist(TempVal5)) THEN
 //            SetDisplayArrow(Arrow1X);
 //            ClearDisplayArrow(ArrowX1);
 //           ELSE
 //            SetDisplayArrow(ArrowX1);
 //            ClearDisplayArrow(Arrow1X);
 //           END_IF;
 //              WHILE (VarioButtons = 0)
 //              END_WHILE;
 //              Waitms(1000);
 //              WHILE (VarioButtons)
 //              END_WHILE;
 
  
            IF (ParaExist(TempVal5)) THEN
             IF (GetParameterMinval(TempVal5) <= TempVal4) THEN
              IF (GetParameterMaxval(TempVal5) >= TempVal4) THEN
//               CreateDisplay();
// ////              SetDisplayText(STRING_TEMP1,1,0,0);
//               SetDisplayValue(TempVal5,1,0,0);
//               SetDisplayValue(TempVal4,2,0,0);
//               WHILE (VarioButtons = 0)
//               END_WHILE;
//               Waitms(1000);
//               WHILE (VarioButtons)
//               END_WHILE;
               SetParameter(TempVal5, TempVal4);
              END_IF;
             END_IF;
            END_IF;
            TempVal4 := 3;//toggle info to ParameterNumber
          END_SELECT;
          StringCopy(STRING_TEMP1,"");
          TempVal3 := TempVal2 + 1;//StartIndex reset
         CASE 61://'='
          TempVal3 := TempVal2 + 1;//StartIndex set, only at start of message
        END_SELECT;
        
 
 /*       
        IF (TempVal3 = 0) THEN//first seach the start of values '='
         SELECT (TempVal2) OF//compare byte
          CASE 61://= //start of value
           TempVal3 := TempVal2;
 //         CASE 44://, //strt of value
 //          TempVal3 := TempVal2;
         END_SELECT;
        ELSE
         SELECT (TempVal2) OF//compare byte
          CASE 44://, //end of value
           TempVal4 := TempVal2;
         END_SELECT;
        END_IF;
               
        IF ((TempVal3 > 0) AND (TempVal4 > 0)) THEN//value found -> convert
         dummy := RS_CopyRxToUserString(STRING_TEMP1,TempVal3 + 1,TempVal4 - TempVal3);//copy substring
         TempVal3 := StringToValue(STRING_TEMP1);
         SetDisplayValue(TempVal3*1,3,0,0);
         Waitms(1000);
         TempVal3 := 0;
         TempVal4 := 0;
        END_IF;
 */       
        //next index
        TempVal1 := TempVal1 + 1;//next index
        CSPD_Counter := CSPD_Counter - 1;//decrement rx buffer length
       END_WHILE;
       SetTaskTime(Val_TASKTIME*1);
     END_SELECT;
END_PROCEDURE
     


//-------------------------------------------------------------------------------------------------------
//Empfangene Nachrichten auswerten und ggf. reagieren
PROCEDURE Handle_INF_Message(HIM_Counter : VALUE, HIM_EX : VALUE)
  HIM_Counter := 1;
  Rx_Message_ID := GetValueRxString(HIM_Counter*1);
  HIM_Counter := HIM_Counter + 1;
  
  IF (BigData_MessageModeWithMessageCounter) THEN
   Rx_Message_Counter := GetValueRxString(HIM_Counter*1);
   HIM_Counter := HIM_Counter + 1;
  END_IF;
  
  IF (StringMessageMode = MM_DONGLE) THEN
   Rx_Message_ID := Rx_Message_ID + 100;//Dongle 
  END_IF; 
  
  IF (HIM_EX) THEN
   Actual_Rx_UniqueIdentifier := GetValueRxString(HIM_Counter*1);
   HIM_Counter := HIM_Counter + 1;
  END_IF;

  IF (StringMessageMode = MM_DONGLE) THEN
   SELECT (Rx_Message_ID) OF
 //---------------------------------------------------Dongle    
    CASE DONGLE_ID_SEND_DETECT_ANSWER_TO_CONTROL_BOX://2
     BigData_Ax_Ack();
     Dongle_Val5 := GetValueRxString(HIM_Counter*1); HIM_Counter := HIM_Counter + 1;
     Dongle_Val6 := GetValueRxString(HIM_Counter*1); HIM_Counter := HIM_Counter + 1;
     Dongle_Val7 := GetValueRxString(HIM_Counter*1); HIM_Counter := HIM_Counter + 1;
     Dongle_Val8 := GetValueRxString(HIM_Counter*1); HIM_Counter := HIM_Counter + 1;
     Ablauf_BigData_Cont := 2;
     
    CASE DONGLE_ID_SEND_ERROR_TO_CONTROL_BOX://4
     Ablauf_BigData_Cont := 110;
    CASE DONGLE_ID_SEND_ACK_TO_CONTROL_BOX://9
     Ablauf_BigData_Cont := 111;
    CASE DONGLE_ID_SEND_GETVERSIONID_ANSWER_TO_CONTROL_BOX://8
     Ablauf_BigData_Cont := 112;
   ELSE:
    SetAllDisplayText(SADT_ERROR_A19,BIGDATA_ERROR_RX_UNKNOWN_COMMAND);
   END_SELECT;
  
  ELSE
  
   SELECT (Rx_Message_ID) OF
 //---------------------------------------------------BigData  
    CASE BIGDATA_ID_SEND_ACK_TO_CONTROL_BOX:
     BigData_Connection_Lost := FALSE;
     //Status_Connection_Lost  := 0;
     IF (ActualDisplay = DISPLAY_WAIT_LOGIN) THEN
      ActualDisplay := DISPLAY_INIT_SEWING;
      SetAllDisplay_KillDisplay();
     END_IF; 
     BigData_Ax_Ack();
     IF (PowerOnRunBlockage) THEN
      //SetDisablePedal := OFF;
      //SetRunBlockage  := OFF;
   flag_BigData_SetDisablePedal  := OFF;
   flag_BigData_SetRunBlockage   := OFF;
      PowerOnRunBlockage := 0;
      //;
     END_IF;
     IF (BigData_NoACKRunBlockage) THEN
      //SetDisablePedal  := OFF;
      //SetRunBlockage   := OFF;
   flag_BigData_SetDisablePedal  := OFF;
   flag_BigData_SetRunBlockage   := OFF;
      SetDisableOutM6  := OFF;
      SetDisableOutM11 := OFF;
      BigData_NoACKRunBlockage := 0;
 //     ;
     END_IF;
 //    IF (BigData_WatchdogTime) THEN
 //     BigData_WatchdogRun := TRUE;
 //    END_IF;
     
    CASE EX_ID_SEND_RESETSERVICECOUNTER:  
     ServiceCounter_ID := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     ServiceCounter_MODE := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     ServiceCounter_Startwert_Temp := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     ServiceCounter_Init(ServiceCounter_ID*1, ServiceCounter_MODE*1, ServiceCounter_Startwert_Temp*1);
     Rx_Message_ID := EX_ID_SEND_ACK_TO_PC;
    CASE BIGDATA_ID_SEND_RESETSERVICECOUNTER:  
     ServiceCounter_ID := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     ServiceCounter_MODE := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     ServiceCounter_Startwert_Temp := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     ServiceCounter_Init(ServiceCounter_ID*1, ServiceCounter_MODE*1, ServiceCounter_Startwert_Temp*1);
     Rx_Message_ID := BIGDATA_ID_SEND_ACK_TO_PC;
 
    CASE EX_ID_SEND_RESETPIECECOUNTER: 
     PieceCounter_ID := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     PieceCounter_MODE  := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     PieceCounter_COUNT_MAX  := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     PieceCounter_COUNT_Act := 0;
     SetParameter(PARA_PIECECOUNTER_COUNT_MAX,PieceCounter_COUNT_MAX);
     SetParameter(PARA_PIECECOUNTER_COUNT_Act,PieceCounter_COUNT_Act);
     Rx_Message_ID := EX_ID_SEND_ACK_TO_PC; 
    CASE BIGDATA_ID_SEND_RESETPIECECOUNTER:  
     PieceCounter_ID := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     PieceCounter_MODE  := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     PieceCounter_COUNT_MAX  := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     PieceCounter_COUNT_Act := 0;
     SetParameter(PARA_PIECECOUNTER_COUNT_MAX,PieceCounter_COUNT_MAX);
     SetParameter(PARA_PIECECOUNTER_COUNT_Act,PieceCounter_COUNT_Act);
     Rx_Message_ID := BIGDATA_ID_SEND_ACK_TO_PC;
     
    CASE BIGDATA_ID_SEND_REQUST_POWER_ON:
     Rx_Message_ID := BIGDATA_ID_SEND_POWER_ON;   
     
     
    CASE EX_ID_SEND_GETPIECECOUNTER: 
     Rx_Message_ID := EX_ID_SEND_PIECECOUNTER_VALUE_0;   
     
     
    CASE EX_ID_SEND_GETPARAMETER:
     GetSetParameterNumber := GetValueRxString(HIM_Counter*1);
     HIM_Counter           := HIM_Counter + 1;    
     GetSetParameterValue  := GetParameter(GetSetParameterNumber);
     Rx_Message_ID         := EX_ID_SEND_GETPARAMETER_ANSWER;
//     CreateDisplay();
//     SetDisplayValue(Actual_Rx_UniqueIdentifier,3,0,0);     
//     SetDisplayValue(GetSetParameterNumber,1,0,0);
//     SetDisplayValue(GetSetParameterValue,2,0,0);
    CASE BIGDATA_ID_SEND_GETPARAMETER:
     GetSetParameterNumber := GetValueRxString(HIM_Counter*1);
     HIM_Counter           := HIM_Counter + 1;    
     GetSetParameterValue  := GetParameter(GetSetParameterNumber);
     Rx_Message_ID         := BIGDATA_ID_SEND_GETPARAMETER_ANSWER;
     
    CASE EX_ID_SEND_EXTERNAL_SERVICE_CALL: 
     BigDataServiceCall_Nr := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     BigDataServiceCall_Status := 1;  
     Rx_Message_ID := EX_ID_SEND_ACK_TO_PC;
     //SetBeepShort();
          
    CASE EX_ID_SEND_SETPARAMETER:
     GetSetParameterNumber := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     GetSetParameterValue  := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     SetParameter(GetSetParameterNumber, GetSetParameterValue);
     Rx_Message_ID := EX_ID_SEND_ACK_TO_PC;
    CASE BIGDATA_ID_SEND_SETPARAMETER:
     GetSetParameterNumber := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     GetSetParameterValue  := GetValueRxString(HIM_Counter*1);
     HIM_Counter := HIM_Counter + 1;    
     SetParameter(GetSetParameterNumber, GetSetParameterValue);
     Rx_Message_ID := BIGDATA_ID_SEND_ACK_TO_PC;
 
    CASE BIGDATA_ID_SEND_SERVICECALL_ACKNOWLEDGE:
     Anzeige_Naht_Text_neu := DISPLAY_INIT_CALL_OK;
     Rx_Message_ID := BIGDATA_ID_SEND_ACK_TO_PC;
 
    CASE BIGDATA_ID_SEND_OPERATOR_ID_ANSWER:
     IF (ActualDisplay = DISPLAY_WAIT_LOGIN) THEN
      ActualDisplay := DISPLAY_INIT_SEWING;
      SetAllDisplay_KillDisplay();
     END_IF; 
     Benutzer_Ebene := GetValueRxString(1);
     flag_BigData_SetEnableFpPedal := OFF;
     BigData_Ax_Ack();


    CASE EX_ID_SEND_REQUEST_INIT_GETPARAMETERDUMP:
     BigDataDataDump_Typ   := GetValueRxString(HIM_Counter*1);
     HIM_Counter           := HIM_Counter + 1;    
     Rx_Message_ID         := EX_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP; 
    CASE BIGDATA_ID_SEND_REQUEST_INIT_GETPARAMETERDUMP:
     BigDataDataDump_Typ   := GetValueRxString(HIM_Counter*1);
     HIM_Counter           := HIM_Counter + 1;   
     Rx_Message_ID         := BIGDATA_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP;
 
    CASE EX_ID_SEND_REQUEST_CONT_GETPARAMETERDUMP:    
     Rx_Message_ID := EX_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP;
    CASE BIGDATA_ID_SEND_REQUEST_CONT_GETPARAMETERDUMP:    
     Rx_Message_ID := BIGDATA_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP;
 
 //   CASE BIGDATA_ID_SEND_REQUEST_INIT_SETPARAMETERDUMP: //nicht benutzt    
 //    BigDataDataDump_Typ  := GetValueRxString(HIM_Counter*1);
 //    HIM_Counter   := HIM_Counter + 1;    
 //    Rx_Message_ID := BIGDATA_ID_SEND_ACK_TO_PC;   
 
    CASE EX_ID_SEND_REQUEST_CONT_SETPARAMETERDUMP:   
     Cont_SetParameterDump(HIM_Counter*1);
     Rx_Message_ID := EX_ID_SEND_ACK_TO_PC;    
    CASE BIGDATA_ID_SEND_REQUEST_CONT_SETPARAMETERDUMP:   
     Cont_SetParameterDump(HIM_Counter*1);
     Rx_Message_ID := BIGDATA_ID_SEND_ACK_TO_PC;   
 
 
 
   ELSE:
 //   CreateDisplay();
 //   TempVal1 := RS_CopyRxToUserString(STRING_OPERATOR,6,10);//Index=6 ist Anfang von ASCII Kennung
 //   SetDisplayText(STRING_OPERATOR,5,0,0);
 //   Waitms(2000);
 //   SetDisplayValue(GetValueRxString(1),1,0,0);
 //   SetDisplayValue(GetValueRxString(2),2,0,0);
 //   SetDisplayValue(GetValueRxString(3),3,0,0);
 //   WHILE (1)
 //   END_WHILE;
    SetAllDisplayText(SADT_ERROR_A19,BIGDATA_ERROR_RX_UNKNOWN_COMMAND);
 
   
   END_SELECT; 
  END_IF; 
END_PROCEDURE


PROCEDURE Send_Rx_Message(SRXM_ID : VALUE)
    IF (Actual_Tx_Info = 0) THEN
     BigData_SendString(SRXM_ID*1);
     Rx_Message_ID := 0;
    END_IF;
END_PROCEDURE

PROCEDURE BigData_Rx_Manager()


 //Erkennung, wenn String von PC->AB geschickt wird
 IF(GetStatusRxString()) THEN
  RxMessageCounter := RxMessageCounter + 1;
//  CreateDisplay();
//  SetDisplayValue(RxMessageCounter,1,0,0);
 // IF (DEBUG_SHOW_RXTX_V900) THEN
 //  CopyFPRxStringToUserString(STRING_Rx);
 //  Debug_Add_Rx_String_V900();
 // END_IF; 
 
//  SetBeepShort();
//  CopyFPRxStringToUserString(STRING_CODE2);
//  SetDisplayText(STRING_CODE2,5,0,0);
 
  IF (CmpRxString("INF")) THEN
//SetDisplayValue(1,1,0,0);   
   Handle_INF_Message(0,NO_EX);  
  END_IF;
  IF (BigData_MessageKeywords) THEN
   IF (CmpRxString("CMD")) THEN
//SetDisplayValue(2,1,0,0);   
    Handle_INF_Message(0,NO_EX);  
   END_IF;
   IF (CmpRxString("RES")) THEN
//SetDisplayValue(3,1,0,0);   
    Handle_INF_Message(0,NO_EX);  
   END_IF;
   IF (CmpRxString("REQ")) THEN
//SetDisplayValue(4,1,0,0);   
    Handle_INF_Message(0,NO_EX);  
   END_IF;
   IF (CmpRxString("DON")) THEN
//SetDisplayValue(5,1,0,0);   
    Handle_INF_Message(0,NO_EX);  
   END_IF;
   IF (CmpRxString("EXCMD")) THEN
//SetDisplayValue(6,1,0,0);   
    Handle_INF_Message(0,WITH_EX);  
   END_IF;
   IF (CmpRxString("EXRES")) THEN
//SetDisplayValue(7,1,0,0);   
    Handle_INF_Message(0,WITH_EX);  
   END_IF;
   IF (CmpRxString("EXREQ")) THEN
//SetDisplayValue(8,1,0,0);   
    Handle_INF_Message(0,WITH_EX);  
   END_IF;
  END_IF;
  ClearStatusRxString();
 END_IF; 



 IF (Rx_Message_ID) THEN
  SELECT (Rx_Message_ID) OF

   CASE EX_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP:
    Send_Rx_Message(Rx_Message_ID*1);
   CASE BIGDATA_ID_SEND_ANSWER_INIT_GETPARAMETERDUMP:
    Send_Rx_Message(Rx_Message_ID*1);

   CASE EX_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP:
    Send_Rx_Message(Rx_Message_ID*1);
   CASE BIGDATA_ID_SEND_ANSWER_CONT_GETPARAMETERDUMP:
    Send_Rx_Message(Rx_Message_ID*1);

   CASE EX_ID_SEND_ACK_TO_PC:
    Send_Rx_Message(Rx_Message_ID*1);
   CASE BIGDATA_ID_SEND_ACK_TO_PC:
    Send_Rx_Message(Rx_Message_ID*1);
   
   CASE EX_ID_SEND_PIECECOUNTER_VALUE_0:
    Send_Rx_Message(Rx_Message_ID*1);
    
   CASE EX_ID_SEND_GETPARAMETER_ANSWER:  
    Send_Rx_Message(Rx_Message_ID*1);
   CASE BIGDATA_ID_SEND_GETPARAMETER_ANSWER:  
    Send_Rx_Message(Rx_Message_ID*1);
    
   CASE BIGDATA_ID_SEND_POWER_ON:
    Send_Rx_Message(Rx_Message_ID*1);

  END_SELECT;
 END_IF;

END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_ServiceCallAutoSend()
//SetDisplayValue(BigDataServiceCall_Nr,1,0,0);
//SetDisplayValue(BigDataServiceCall_Status,2,0,0);
 IF (BigDataServiceCall_Status <> 0) THEN
 IF (NOT TimerIsRunning(TIMER_SERVICECALLAUTOSEND)) THEN
 
 SELECT (BigDataServiceCall_Status) OF

//  ELSE:
//   BigDataServiceCall_Status := 0;
//   BigDataServiceCall_Nr     := 0;
   
  CASE 1:
   SetTimer(TIMER_SERVICECALLAUTOSEND,4000);
   BigDataServiceCall_Status := 2;

  CASE 2:
   VAL_SERVICE_NUMBER        := BigDataServiceCall_Nr;
   BigDataServiceCall_Status := 0;
   BigDataServiceCall_Nr     := 0;
   BigData_SendString(BIGDATA_ID_SEND_SERVICE_CALL);
//   SetBeepShort();

 END_SELECT;  
 END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_RxTx_Manager()

BigData_ServiceCallAutoSend();

//Repeat message until ACK
BigData_Tx_Manager();

//Receive and Handle Message
BigData_Rx_Manager();

END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
END_UNIT
